#include "stm32f10x_spi.h"
#include "ILI9341.h"


#define CS 0     //0 sterowanie sprzetowe 1- sterowanie programowe

#define Reset_H    GPIOA->BSRR = GPIO_Pin_10
#define Reset_L    GPIOA->BRR = GPIO_Pin_10
#define WR_H    GPIOA->BSRR = GPIO_Pin_9
#define WR_L    GPIOA->BRR = GPIO_Pin_9
#define CSILI_H   GPIOA->BSRR = GPIO_Pin_11
#define CSILI_L    GPIOA->BRR = GPIO_Pin_11

extern volatile uint32_t TIMERUS;


void ILI9341_InitLCD(void) 
{

	 ILI9341_Delay(1000); //Odczekaj 50ms
	 // Wymuszczenie resetu sprzetowego 
	 Reset_L;
	 ILI9341_Delay(500); //Odczekaj 50ms
     Reset_H;
	 ILI9341_Delay(500); //odczekaj 50ms
	 // Programowy reset
	 ILI9341_SendCommand(0x01); //komenda resetu

     ILI9341_Delay(500); //odczekaj 50ms

	
	//Ustawienia kontroler - wedlug producenta wyswietlacza
	
	ILI9341_SendCommand(0xCB); //PowerA - wybory zasilania np rdzenia vcore control itd - komedna w wersji extend
	ILI9341_SendData(0x39);    //wartosc wedlug noty
	ILI9341_SendData(0x2C);    //wartosc wedlug noty
	ILI9341_SendData(0x00);    //wartosc wedlug noty
	ILI9341_SendData(0x34);    //zasilanie rdzenia 1,6V
	ILI9341_SendData(0x02);    //ddvdh control 5,6V
	ILI9341_SendCommand(0xCF); //PowerB
	ILI9341_SendData(0x00);	   //wartosc wedlug noty
	ILI9341_SendData(0xC1);   //Vgl-Vclx4, Vgh-Vclx7, DDVDH-VCLx2. DRV_en=0, PC and EQ operation for power saving enable
	ILI9341_SendData(0x30);   //DRVvmh 000, DRVvml=0, discharge path enable, DRV_vml-00
	ILI9341_SendCommand(0xE8); //DTCA
	ILI9341_SendData(0x85);   //gate driver non-overlap timing control=1
	ILI9341_SendData(0x00);   //EQ Timing control=0, CR Timing control=0
	ILI9341_SendData(0x78);   //pre - changing timing control=00;
	ILI9341_SendCommand(0xEA); //DTCB - driver timming control 
	ILI9341_SendData(0x00);    //EQ to GND=0, EQ to DDVDH=0, EQ to DDVDH=0, EQ to GND
	ILI9341_SendData(0x00);    // Wedlug noty
	ILI9341_SendCommand(0xED); //Power on sequence control
	ILI9341_SendData(0x64);   //CP23 soft start - keep 3 frame, CP1 soft start - keep 1 frame
	ILI9341_SendData(0x03);	  //En_ddvdh - 4th frame enable , EN_vcl - 1st frame enable, 
	ILI9341_SendData(0x12);   //EN_vgl- 3th frame enable, EN_vgh- 2th frame enable
	ILI9341_SendData(0x81);   //DDVDH - enable
	ILI9341_SendCommand(0xF7);  //Pump ratio control
	ILI9341_SendData(0x20);	    //DDVDH=2xVcl
	ILI9341_SendCommand(0xC0); //Power 1
	ILI9341_SendData(0x23);    //set the GVDD level -reference level for Vcom 4,6V
	ILI9341_SendCommand(0xC1); //Power 2
	ILI9341_SendData(0x10);    // -
	ILI9341_SendCommand(0xC5); //Vcom control 1
	ILI9341_SendData(0x3E);    //4,25V - VCOMH voltage
	ILI9341_SendData(0x28);    //-1,5V - VCOML voltage
	ILI9341_SendCommand(0xC7); //Vcom control 2
	ILI9341_SendData(0x86);	   //VMH-58, VML-58, nVM=1
	ILI9341_SendCommand(0x36); //Dostep do pamieci
	ILI9341_SendData(0x08);   //- --// 0x00// 0x08--------0x48 //orientacja wyswietlacz pionowa - bez zmian
	ILI9341_SendCommand(0x3A); // Format Pixeli
	ILI9341_SendData(0x55);    //16 bit/pixel , 16bit/pixel
	ILI9341_SendCommand(0xB1); //Frame rate control
	ILI9341_SendData(0x00);    //internal ratio for division ratio - fosc
	ILI9341_SendData(0x18);    //RTNA - 79Hz
	ILI9341_SendCommand(0xB6); //Display function control
	ILI9341_SendData(0x08);    //Pt-0,0 PTG-1,0
	ILI9341_SendData(0x82);    //ISC - 5frames 85ms , REV - normaly white crystal
	ILI9341_SendData(0x27);    //NL - 320 lines - size of crystal panel
	
	ILI9341_SendCommand(0x2A); //Column Adres - wraz z page adres - wypelnienie calego obszaru
	ILI9341_SendData(0x00);        
	ILI9341_SendData(0x00);
	ILI9341_SendData(0x00);	       
	ILI9341_SendData(0xEF);
	ILI9341_SendCommand(0x2B);
	ILI9341_SendData(0x00);
	ILI9341_SendData(0x00);       
	ILI9341_SendData(0x01);	      
	ILI9341_SendData(0x3F);
	
	//***************************************************************************************
	// 			Funkcje ustawiajace Gamme
	//***************************************************************************************
	

	ILI9341_SendCommand(0xF2);
	ILI9341_SendData(0x00);
	
	ILI9341_SendCommand(0x26);
	ILI9341_SendData(0x01);
	ILI9341_SendCommand(0xE0);
	ILI9341_SendData(0x0F);
	ILI9341_SendData(0x31);
	ILI9341_SendData(0x2B);
	ILI9341_SendData(0x0C);
	ILI9341_SendData(0x0E);
	ILI9341_SendData(0x08);
	ILI9341_SendData(0x4E);
	ILI9341_SendData(0xF1);
	ILI9341_SendData(0x37);
	ILI9341_SendData(0x07);
	ILI9341_SendData(0x10);
	ILI9341_SendData(0x03);
	ILI9341_SendData(0x0E);
	ILI9341_SendData(0x09);
	ILI9341_SendData(0x00);
	ILI9341_SendCommand(0xE1);  //Ngamma - set gray scale voltage to adjust the gamma
	ILI9341_SendData(0x00);
	ILI9341_SendData(0x0E);
	ILI9341_SendData(0x14);
	ILI9341_SendData(0x03);
	ILI9341_SendData(0x11);
	ILI9341_SendData(0x07);
	ILI9341_SendData(0x31);
	ILI9341_SendData(0xC1);
	ILI9341_SendData(0x48);
	ILI9341_SendData(0x08);
	ILI9341_SendData(0x0F);
	ILI9341_SendData(0x0C);
	ILI9341_SendData(0x31);
	ILI9341_SendData(0x36);
	ILI9341_SendData(0x0F);

	ILI9341_SendCommand(0x11);  //Sleep out

	ILI9341_Delay(500); //odczekaj 50ms

	ILI9341_SendCommand(0x29); //Display on
	ILI9341_SendCommand(0x2C);  //Wpisywanie do pamieci wyswietlacza aby wyswietlac GRAM
}


void ILI9341_SendCommand(uint8_t data) 
{
	// wykasowanie lini WRX
	WR_L;
	//wykasowanie lini CS
	#if CS==1
	CSILI_L
	#endif
	while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE)==RESET){}  //odczekaj az buffor wysylajacy bedzie pusty
	SPI_I2S_SendData(SPI1, data);
	//podniesienie w stan wysoki lini CS
	#if CS==1
	CSILI_H
	#endif
}

void ILI9341_SendData(uint8_t data)
{
	//podniesienie lini WRX w stan wysoki
	WR_H;
	//wykasowanie lini Chip select
	#if CS==1
	CSILI_L
	#endif
	while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE)==RESET){} //odczekaj az buffor wysylajacy bedzie pusty
	SPI_I2S_SendData(SPI1,data);
  //podniesienie lini w stan wysoki CS
	#if CS==1
	CSILI_H
	#endif
}

void ILI9341_SetCursorPosition(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2) //funkcja sluzaca do zaznaczenia aktywnego obszaru
 {
	ILI9341_SendCommand(0x2A);     //Column adress - ilosc lini w poziomie
	ILI9341_SendData(x1 >> 8);
	ILI9341_SendData(x1 & 0xFF);
	ILI9341_SendData(x2 >> 8);
	ILI9341_SendData(x2 & 0xFF);

	ILI9341_SendCommand(0x2B); //Page adress - ilosc lini w pionie
	ILI9341_SendData(y1 >> 8);
	ILI9341_SendData(y1 & 0xFF);
	ILI9341_SendData(y2 >> 8);
	ILI9341_SendData(y2 & 0xFF);
	 
	ILI9341_SendCommand(0x2c);
}

void ILI9341_DrawPixel(uint16_t x, uint16_t y, uint32_t color) //rysowanie pixela o wybranym kolorze
{

		ILI9341_SetCursorPosition(x, y, x, y);

			ILI9341_SendCommand(0x2C);   //wpisywanie wartosci do GRAM
			ILI9341_SendData(color >> 8);        //format 16bitowy 565 -wyslanie starszej czesci
			ILI9341_SendData(color & 0xFF);      //wyslanie mlodszej czesci

}

void ILI9341_DrawPixel2(uint16_t x, uint16_t y, uint32_t color) //rysowanie pixela o wybranym kolorze
{

		ILI9341_SetCursorPosition(x, y, x, y);

			ILI9341_SendData(color >> 8);        //format 16bitowy 565 -wyslanie starszej czesci
			ILI9341_SendData(color & 0xFF);      //wyslanie mlodszej czesci

}

void ILI9341_DisplayOn(void)  //zalaczenie wyswietlacza
{
	ILI9341_SendCommand(0x29); //komenda zalaczajaca wyswietlanie
}

void ILI9341_DisplayOff(void)  //wylaczenie wyswietlacza
{
	ILI9341_SendCommand(0x28); //komenda wylaczajaca wyswietlanie
}

//rysowanie linii
void tft_line(int X1, int Y1,int X2,int Y2,int Color) 
	{
	int CurrentX, CurrentY, Xinc, Yinc,
		Dx, Dy, TwoDx, TwoDy,
		TwoDxAccumulatedError, TwoDyAccumulatedError;

	Dx = (X2-X1);
	Dy = (Y2-Y1);

	TwoDx = Dx + Dx;
	TwoDy = Dy + Dy;

	CurrentX = X1;
	CurrentY = Y1;

	Xinc = 1;
	Yinc = 1;

	if(Dx < 0) {

		Xinc = -1;
		Dx = -Dx;
		TwoDx = -TwoDx;
	}

	if (Dy < 0) {
		Yinc = -1;
		Dy = -Dy;
		TwoDy = -TwoDy;
	}

	ILI9341_DrawPixel(Y1, X1, Color);
	

	if ((Dx != 0) || (Dy != 0)) {

		if (Dy <= Dx) {
			TwoDxAccumulatedError = 0;
			do {
			    CurrentX += Xinc;
			    TwoDxAccumulatedError += TwoDy;
			    if(TwoDxAccumulatedError > Dx) {
			        CurrentY += Yinc;
			        TwoDxAccumulatedError -= TwoDx;
			    }
					ILI9341_DrawPixel(CurrentY, CurrentX, Color);

			
			  } while (CurrentX != X2);
		  } else {
			  TwoDyAccumulatedError = 0;
			  do {
			      CurrentY += Yinc;
			      TwoDyAccumulatedError += TwoDx;
			      if(TwoDyAccumulatedError>Dy) {
				      CurrentX += Xinc;
				      TwoDyAccumulatedError -= TwoDy;
			      }
						ILI9341_DrawPixel(CurrentY, CurrentX, Color);
			    
			  } while (CurrentY != Y2);
		  }
	}
}
	//rysowanie pelnego prostokatu
void full_rect( int X1, int Y1, int X2, int Y2, uint16_t color)
{
				int i, j;
		for(i=X1; i<=X2; i++)
		{
					for(j=Y1; j<=Y2; j++)
					{
						ILI9341_DrawPixel(j, i, color);
					}
		}
}	

 void ILI9341_Delay(volatile unsigned int delay) //funkcja opozniajaca
{
	 	TIMERUS=delay;
		while(TIMERUS){}
}

void ILI9341_Clear(uint16_t color) //funkcja czyszczasa ekran danym kolorem
{
	//full_rect( 0, 0, 320, 240, color);
	uint32_t k;

	ILI9341_SetCursorPosition(0, 0, 240, 320);

	ILI9341_SendCommand(0x2C);   //wpisywanie wartosci do GRAM
	for(k=0; k<=76799; k++)
	{
		ILI9341_SendData(color >> 8);        //format 16bitowy 565 -wyslanie starszej czesci
		ILI9341_SendData(color & 0xFF);      //wyslanie mlodszej czesci
	}
}

//wstawianie obrazka logo firmy
void putpictures(u16 x, u16 y, u16 width, u16 height, unsigned char const *grafika, uint8_t scale, uint8_t alpha)   // scale oznacza skale obrazka np 1:1, 1:2, 1:3
{
		u16 i, j, t;
		unsigned char const *s;

		s=grafika;


		for(j=0; j<height; j++)
		{
				for(i=0; i<width; i++)
				{
					t=(*s);
					s++;
					t=t | (*s<<8);
					s++;

					switch(scale)
					{
					case 1:
					{
						ILI9341_DrawPixel(y+j, x+i, t);
					}
					case 2:
					{
						ILI9341_DrawPixel(y+(2*j), x+(2*i), t);
					if(!alpha)ILI9341_DrawPixel(y+(2*j), x+(2*i)+1, t);   //Oblokowanie komentarzy powoduje napis normalny a nie zamglony
					if(!alpha)ILI9341_DrawPixel(y+(2*j)+1, x+(2*i), t);
						ILI9341_DrawPixel(y+(2*j)+1, x+(2*i)+1, t);
					}
					}
				}
		}
}

void putfastpicscal2(u16 x, u16 y, u16 width, u16 height, unsigned char const *grafika)   // scale oznacza skale obrazka np 1:1, 1:2, 1:3
{
		u16 i, k, tp;
		unsigned char msb, lsb;
		unsigned char const *s, *temp;


		        s=grafika;
				ILI9341_SendCommand(0x2C);   //wpisywanie wartosci do GRAM

				for(tp=0; tp<height; tp++)   //240 powtorzenia poniewaz tyle mamy wierszy
				{

                    temp=s;
				    for(k=0; k<2; k++)
				    {
				    ILI9341_SetCursorPosition(y+(tp*2)+k, x,y+(tp*2)+k , x+(width*2)); //funkcja sluzaca do zaznaczenia aktywnego obszaru

				    if(k) s=temp;
				    for(i=0; i<(width); i++)
				    				{
				    					lsb=*s;
				    					s++;
				    					msb=*s;
				    					s++;
				    					ILI9341_SendData(msb);        //format 16bitowy 565 -wyslanie starszej czesci
				    					ILI9341_SendData(lsb);        //format 16bitowy 565 -wyslanie mlodczej czesci
				    					ILI9341_SendData(msb);        //format 16bitowy 565 -wyslanie starszej czesci
				    					ILI9341_SendData(lsb);        //format 16bitowy 565 -wyslanie mlodczej czesci
				    				}
				    }

				}
}

//rysowanie linii - pogrubionej
void tft_line2(int X1, int Y1,int X2,int Y2,int Color)
	{
	uint8_t p;
	int CurrentX, CurrentY, Xinc, Yinc,
		Dx, Dy, TwoDx, TwoDy,
		TwoDxAccumulatedError, TwoDyAccumulatedError;

	Dx = (X2-X1);
	Dy = (Y2-Y1);

	TwoDx = Dx + Dx;
	TwoDy = Dy + Dy;

	CurrentX = X1;
	CurrentY = Y1;

	Xinc = 1;
	Yinc = 1;

	if(Dx < 0) {

		Xinc = -1;
		Dx = -Dx;
		TwoDx = -TwoDx;
	}

	if (Dy < 0) {
		Yinc = -1;
		Dy = -Dy;
		TwoDy = -TwoDy;
	}



	ILI9341_SetCursorPosition(Y1-3, X1-3, Y1+3, X1+3);

	ILI9341_SendCommand(0x2C);   //wpisywanie wartosci do GRAM

	for(p=0; p<49; p++)
	{
	ILI9341_SendData(Color >> 8);        //format 16bitowy 565 -wyslanie starszej czesci
	ILI9341_SendData(Color & 0xFF);      //wyslanie mlodszej czesci
	}


	if ((Dx != 0) || (Dy != 0)) {

		if (Dy <= Dx) {
			TwoDxAccumulatedError = 0;
			do {
			    CurrentX += Xinc;
			    TwoDxAccumulatedError += TwoDy;
			    if(TwoDxAccumulatedError > Dx) {
			        CurrentY += Yinc;
			        TwoDxAccumulatedError -= TwoDx;
			    }


			    ILI9341_SetCursorPosition(CurrentY-1, CurrentX-1, CurrentY+1, CurrentX+1);

			    for(p=0; p<9; p++)
			    	{
			    	ILI9341_SendData(Color >> 8);        //format 16bitowy 565 -wyslanie starszej czesci
			    	ILI9341_SendData(Color & 0xFF);      //wyslanie mlodszej czesci
			    	}


			  } while (CurrentX != X2);
		  } else {
			  TwoDyAccumulatedError = 0;
			  do {
			      CurrentY += Yinc;
			      TwoDyAccumulatedError += TwoDx;
			      if(TwoDyAccumulatedError>Dy) {
				      CurrentX += Xinc;
				      TwoDyAccumulatedError -= TwoDy;
			      }
				    ILI9341_SetCursorPosition(CurrentY-1, CurrentX-1, CurrentY+1, CurrentX+1);

				    for(p=0; p<9; p++)
				    	{
				    	ILI9341_SendData(Color >> 8);        //format 16bitowy 565 -wyslanie starszej czesci
				    	ILI9341_SendData(Color & 0xFF);      //wyslanie mlodszej czesci
				    	}


			  } while (CurrentY != Y2);
		  }
	}
}


void tft_line3(int X1, int Y1,int X2,int Y2,int Color)
	{
	uint8_t p;
	int CurrentX, CurrentY, Xinc, Yinc,
		Dx, Dy, TwoDx, TwoDy,
		TwoDxAccumulatedError, TwoDyAccumulatedError;

	Dx = (X2-X1);
	Dy = (Y2-Y1);

	TwoDx = Dx + Dx;
	TwoDy = Dy + Dy;

	CurrentX = X1;
	CurrentY = Y1;

	Xinc = 1;
	Yinc = 1;

	if(Dx < 0) {

		Xinc = -1;
		Dx = -Dx;
		TwoDx = -TwoDx;
	}

	if (Dy < 0) {
		Yinc = -1;
		Dy = -Dy;
		TwoDy = -TwoDy;
	}



	ILI9341_SetCursorPosition(Y1, X1, Y1, X1);

	ILI9341_SendCommand(0x2C);   //wpisywanie wartosci do GRAM


	ILI9341_SendData(Color >> 8);        //format 16bitowy 565 -wyslanie starszej czesci
	ILI9341_SendData(Color & 0xFF);      //wyslanie mlodszej czesci



	if ((Dx != 0) || (Dy != 0)) {

		if (Dy <= Dx) {
			TwoDxAccumulatedError = 0;
			do {
			    CurrentX += Xinc;
			    TwoDxAccumulatedError += TwoDy;
			    if(TwoDxAccumulatedError > Dx) {
			        CurrentY += Yinc;
			        TwoDxAccumulatedError -= TwoDx;
			    }


			    ILI9341_SetCursorPosition(CurrentY-1, CurrentX-1, CurrentY+1, CurrentX+1);

			    for(p=0; p<9; p++)
			    	{
			    	ILI9341_SendData(Color >> 8);        //format 16bitowy 565 -wyslanie starszej czesci
			    	ILI9341_SendData(Color & 0xFF);      //wyslanie mlodszej czesci
			    	}


			  } while (CurrentX != X2);
		  } else {
			  TwoDyAccumulatedError = 0;
			  do {
			      CurrentY += Yinc;
			      TwoDyAccumulatedError += TwoDx;
			      if(TwoDyAccumulatedError>Dy) {
				      CurrentX += Xinc;
				      TwoDyAccumulatedError -= TwoDy;
			      }
				    ILI9341_SetCursorPosition(CurrentY-1, CurrentX-1, CurrentY+1, CurrentX+1);

				    for(p=0; p<9; p++)
				    	{
				    	ILI9341_SendData(Color >> 8);        //format 16bitowy 565 -wyslanie starszej czesci
				    	ILI9341_SendData(Color & 0xFF);      //wyslanie mlodszej czesci
				    	}


			  } while (CurrentY != Y2);
		  }
	}
}

//Funkcja rysujaca narysowana grafike w monohromatyczna w pikselach
//w tablicy sa zawarte informacje o pikselach - wierszowo
uint8_t putmonograph(uint16_t x, uint16_t y, uint16_t color, uint16_t bkcolor, uint16_t width, uint16_t height,const uint8_t *s)
{
	uint8_t tempi, tempk, wier, dtemp=0, fault=0;
	unsigned char wartosc;
	const uint8_t *p;

	//jezeli wysokosc i szerokosc nie jest podzielna przez 8 to zwroc blad
	if(height%8) fault= 1;
	if(width%8) fault= 1;

	wier=width/8;

	for(tempk=0; tempk<height; tempk++)
	{
	for(tempi=0; tempi<wier; tempi++)
	{
		p=s+(tempk*wier)+tempi;
		wartosc=*p;
		for(dtemp=0; dtemp<8; dtemp++)
		{
			if(wartosc & (1<<(7-dtemp))) ILI9341_DrawPixel(y+tempk, x+(tempi*8)+dtemp, color); else ILI9341_DrawPixel(y+tempk, x+(tempi*8)+dtemp, bkcolor);
		}

	}
	}

	return fault;
}

//Funkcja rysujaca pojedynczy zaokraglony kwadrat
void tft_round_rect1(int x, int y, int width, int height, uint8_t radius, uint8_t fill, uint16_t color)
{
  	int16_t tSwitch;

  	int x1 = 0, y1 = radius;
  	tSwitch = 3 - 2 * radius;

	while (x1 <= y1) {

		ILI9341_DrawPixel(y+radius - y1, x+radius - x1, color);
		ILI9341_DrawPixel(y+radius - x1, x+radius - y1, color);
		ILI9341_DrawPixel( y+radius - y1, x+width-radius + x1, color);
		ILI9341_DrawPixel( y+radius - x1, x+width-radius + y1, color);
		ILI9341_DrawPixel(y+height-radius + y1, x+width-radius + x1, color);
		ILI9341_DrawPixel(y+height-radius + x1, x+width-radius + y1, color);
		ILI9341_DrawPixel(y+height-radius + y1, x+radius - x1, color);
		ILI9341_DrawPixel(y+height-radius + x1,x+radius - y1, color);


			tft_line(x+radius - x1, y+radius - y1, x+width-radius + x1, y+radius - y1, color);
			tft_line(x+radius - y1, y+radius - x1, x+width-radius + y1, y+radius - x1 ,color);
			tft_line(x+width-radius + x1, y+height-radius + y1, x+radius - x1, y+height-radius + y1, color);
			tft_line(x+width-radius + y1, y+height-radius + x1, x+radius - y1, y+height-radius + x1, color);


	    if (tSwitch < 0) {
	    	tSwitch += (4 * x1 + 6);
	    } else {
	    	tSwitch += (4 * (x1 - y1) + 10);
	    	y1--;
	    }
	    x1++;
	}

		uint16_t i;
		for(i=0; i<height-(2*radius); i++) tft_line(x, y+radius+i, x+width, y+radius+i, color);

	tft_line(x+radius, y, x+width-radius, y, color);
	tft_line(x+radius, y+height, x+width-radius, y+height, color);

	tft_line(x, y+radius, x, y+height-radius, color);
	tft_line(x+width, y+radius, x+width, y+height-radius, color);
}

//Kwadrat z zaokraglonynmi krawedziami
void tft_round_rect(int x, int y, int width, int height, uint8_t radius, uint16_t color1, uint16_t color2)
{
		tft_round_rect1(x,y,width,height, radius,1, color1);
		tft_round_rect1(x+2,y+2,width-4,height-4, radius,1, color2);
}

void full_rect3( int X1, int Y1, int X2, int Y2, uint16_t color)
{
	uint16_t temp1, temp2;
	uint32_t tempmul;
	uint32_t k;

	temp1=X2-X1;
	temp2=Y2-Y1;

	tempmul=(temp1+1)*(temp2+1);

	ILI9341_SetCursorPosition(Y1, X1, Y2, X2);

	ILI9341_SendCommand(0x2C);   //wpisywanie wartosci do GRAM
	for(k=0; k<=tempmul; k++)
	{
		ILI9341_SendData(color >> 8);        //format 16bitowy 565 -wyslanie starszej czesci
		ILI9341_SendData(color & 0xFF);      //wyslanie mlodszej czesci
	}


}

void lcdputvalue(u16 x, u16 y, u16 value, u16 color)
{
	u16 tysieczne, setne, dziesietne, jednosci; //zmienne ktore przechowywuja wartosci do wpisania w bufor i wyswietlenia
	//obliczenie ile jest tysiecznych, setnych, dziesietnych i jednosci
	char buforvalue[5];

	tysieczne=value/1000;
    setne=(value-(1000*tysieczne))/100;
	dziesietne=(value-(1000*tysieczne)-(100*setne))/10;
	jednosci=value-(1000*tysieczne)-(100*setne)-(10*dziesietne);

	//wpisanie do buforvalue wartosci w kodzie ASCII
	buforvalue[0]=0x30+tysieczne;
	buforvalue[1]=0x30+setne;
	buforvalue[2]=0x30+dziesietne;
	buforvalue[3]=0x30+jednosci;
	buforvalue[4]=0x00;  //Null konczacy wpisywanie danych



	tft_mputs( x, y, buforvalue, color, White, 0);
}

//Narysowanie obrazka z pamieci flash
void putpictures2(u16 x, u16 y, u16 width, u16 height, unsigned char const *grafika)
{
		u16 i, j;
		unsigned char const *s;
		unsigned char msb, lsb;

		s=grafika;


		for(j=0; j<height; j++)
		{

			ILI9341_SetCursorPosition(y+j, x,y+j , x+width); //funkcja sluzaca do zaznaczenia aktywnego obszaru
            ILI9341_SendCommand(0x2C);   //wpisywanie wartosci do GRAM

				for(i=0; i<width; i++)
				{
					lsb=*s;
					s++;
					msb=*s;
					s++;
					ILI9341_SendData(msb);        //format 16bitowy 565 -wyslanie starszej czesci
					ILI9341_SendData(lsb);        //format 16bitowy 565 -wyslanie mlodszej czesci
				}
		}
}

void putpictures3(u16 x, u16 y, unsigned char const *grafika)   //funkcja rysujaca pomniejszony o polowe obrazek 320x240 czyli w rozdzielczosci 160x120
{
		u16 i, j, t;
		unsigned char const *s;
		unsigned char msb, lsb;

		s=grafika;


		for(j=0; j<120; j++)
		{

			ILI9341_SetCursorPosition(y+j, x,y+j , x+160); //funkcja sluzaca do zaznaczenia aktywnego obszaru
            ILI9341_SendCommand(0x2C);   //wpisywanie wartosci do GRAM

				for(i=0; i<160; i++)
				{
					lsb=*s;
					s++;
					msb=*s;
					s++;
					ILI9341_SendData(msb);        //format 16bitowy 565 -wyslanie starszej czesci
					ILI9341_SendData(lsb);        //format 16bitowy 565 -wyslanie mlodczej czesci
					s++;
					s++;
				}
				for(t=0; t<320; t++)
				{
					s++;
					s++;
				}
		}
}


void alpharectangle(u16 x1, u16 y1, u16 x2, u16 y2, u16 color, u8 border)  //funkcja rysujaca przezroczysty kwadrat - wpisanie 1 do border aktwuje rysowanie obramowania
{
	u16 i, j, k;
	u16 temp1, temp2;
	uint8_t color1, color2;

	temp1=(x2-x1)/2;
	temp2=(y2-y1)/2;

	color1=color >> 8;
	color2=color & 0xFF;

	for(i=0; i<=temp1; i++)
	{
		for(j=0; j<=temp2; j++)
		{


			/* if(border)
			 {*/
			 if(i==0 || j==0 || i==temp1 || j==temp2)
			 {

				 ILI9341_SetCursorPosition(y1+(2*j),  x1+(2*i), y1+(2*j)+1, x1+(2*i)+1);

				 for(k=0; k<4; k++)
				 {
				 ILI9341_SendData(color1);        //format 16bitowy 565 -wyslanie starszej czesci
				 ILI9341_SendData(color2);      //wyslanie mlodszej czesci
				 }

			 }
			 else
			 {
				 ILI9341_SetCursorPosition(y1+(2*j),  x1+(2*i), y1+(2*j), x1+(2*i));
				 ILI9341_SendData(color1);        //format 16bitowy 565 -wyslanie starszej czesci
				 ILI9341_SendData(color2);      //wyslanie mlodszej czesci

				 ILI9341_SetCursorPosition(y1+(2*j)+1,  x1+(2*i)+1, y1+(2*j)+1, x1+(2*i)+1);
				 ILI9341_SendData(color1);        //format 16bitowy 565 -wyslanie starszej czesci
				 ILI9341_SendData(color2);      //wyslanie mlodszej czesci
			 }
			 /*}
			 else
			 {
				  ILI9341_SetCursorPosition(y1+(2*j),  x1+(2*i), y1+(2*j), x1+(2*i));
				 ILI9341_SendData(color1);        //format 16bitowy 565 -wyslanie starszej czesci
				 ILI9341_SendData(color2);      //wyslanie mlodszej czesci

				 ILI9341_SetCursorPosition(y1+(2*j)+1,  x1+(2*i)+1, y1+(2*j)+1, x1+(2*i)+1);
				 ILI9341_SendData(color1);        //format 16bitowy 565 -wyslanie starszej czesci
				 ILI9341_SendData(color2);      //wyslanie mlodszej czesci
			 }*/

		}
	}
}

void lcdputvalue2(u16 x, u16 y, u16 value, u16 color)
{
	u16  dziesietne, jednosci; //zmienne ktore przechowywuja wartosci do wpisania w bufor i wyswietlenia
	//obliczenie ile jest tysiecznych, setnych, dziesietnych i jednosci
	char buforvalue[3];

	dziesietne=value/10;
	jednosci=value%10;

	buforvalue[0]=0x30+dziesietne;
	buforvalue[1]=0x30+jednosci;
	buforvalue[2]=0x00;  //Null konczacy wpisywanie danych



	tft_mputs( x, y, buforvalue, color, White, 0);
}

//funkcja wypisujaca stan liczby w sposob binarny
void lcdputvalue3(u16 x, u16 y, u16 value, u16 color)
{

	//obliczenie ile jest tysiecznych, setnych, dziesietnych i jednosci
	char buforvalue[5];

	if(value & 0x01) buforvalue[3]=0x31; else buforvalue[3]=0x30;
	if(value & 0x02) buforvalue[2]=0x31; else buforvalue[2]=0x30;
	if(value & 0x04) buforvalue[1]=0x31; else buforvalue[1]=0x30;
	if(value & 0x08) buforvalue[0]=0x31; else buforvalue[0]=0x30;

	buforvalue[4]=0x00;  //Null konczacy wpisywanie danych

	tft_mputs( x, y, buforvalue, color, White, 0);
}
