#include "stm32f10x.h"
#include "xpt2046.h"




//Uwaga - na linia sygnalowej IRQ z touch panelu wystepuja bardzo duze drgania ktore nalezy wyelyminowac programowo



void XPT2046_SPI_Init(void) //inicjalizacja interfejsu SPI 
{
  GPIO_InitTypeDef  GPIO_InitStructure;
  SPI_InitTypeDef   SPI_InitStructure;
	
			//RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI2, ENABLE);


      SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex; //okreslienie wyboru trybu transmisji 
		//(lilcza lini i kierunek wymiany danych)
      SPI_InitStructure.SPI_Mode = SPI_Mode_Master; //okreslenie trybu pracy ukladu SPI (master)
	  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b; //okreslenie wielkosci wysylanych danych -> 8 bitow
      SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low; //okreslenie stnu lini SCK przy braku transmiji -> niski
      SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge; //okreslenie aktywne zbocze sygnalu SCK
																										//dane brane z noty XPT2046
      SPI_InitStructure.SPI_NSS = SPI_NSS_Soft; //sposob sterowania linia CS - programowy
      SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256; //okreslenie wartosci dzielnika czestotliwosci ->128
      SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB; //okresla kolejnosc transmisji bitow slowa danych -> najbardziej znaczacy bit wysylany w pierwszej kolejnosci
      SPI_InitStructure.SPI_CRCPolynomial = 0; // okreslenie rzadu wielomianu sumy CRC  - normalnie nie wykorzystujemy
      SPI_Init(SPI2, &SPI_InitStructure); //wpsianie konfiguracji do struktury
	  SPI_Cmd(SPI2, ENABLE); // Zalaczenie interfejsu SPI
	

 
			//porty pod ktore bedzie podlaczony interfejs SPI
      /*   SPI_CS_GPIO = PB12,
       *   SPI_MOSI_GPIO = PB15,
       *   SPI_MISO_GPIO = PB14,
       *   SPI_SCK_GPIO = PB13 *
		//jezeli SPI1 nie jest zalaczony to zalaczmy porty GPIOB oraz interfejs SPI */
      //  SPI1 Periph clock - zalaczenie sygnalu zegarowego dla SPI
      
		
      //< Konfiguracja SPI1 pinow: SCK, MISO, MOSI 
      GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15 | GPIO_Pin_13 | GPIO_Pin_14;
      GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
      GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
      GPIO_Init(GPIOB, &GPIO_InitStructure);

	
   
  /*!< Configure SPI1 pin: TouchScreen CS pin */
  //Dla kontroli sterowania wyswietlacz Pin13 reset , Pin14 CSRW Pin15 ewentualny nSS
      		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
      		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
      		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
      		GPIO_Init(GPIOB, &GPIO_InitStructure);

      		GPIOB->BSRR = GPIO_Pin_12;
  
 XPT2046_SendByte(0x00);//wyzerowanie danych poprzez wyslanie zerowych bitow
 XPT2046_SendByte(0x00);
 XPT2046_SendByte(0x00);
}


 


uint8_t XPT2046_SendByte(uint8_t byte)
{
  /* petla nieskonczona jesli rejest DR register nie jest pusty */
  while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET)
	  {
	  }

  /* wyslij bajt */
	SPI_I2S_SendData(SPI2, (uint16_t)byte);

  /*czekaj na dane*/
  while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET);

  /* zwroc bajt odczytany z interfejsi SPI */
  return (uint8_t)SPI_I2S_ReceiveData(SPI2);
}


uint8_t XPT2046_ReadByte(void)
	//odczytaj bajt
{
	//odczytaj bajt w odpowiedzi na wyslanie zerowego bajtu
  return (XPT2046_SendByte(0x00));
}

uint16_t ADS_Read_AD(uint8_t CMD)
{
  uint16_t temp,Addata;
  
	CS_L;
  XPT2046_SendByte(CMD);
  temp=0;
	//
 //XPT2046_ReadByte();
	//
  temp= XPT2046_ReadByte();
  Addata =temp<<8;
	temp=0;
  temp= XPT2046_ReadByte();
  Addata |=temp;
  Addata >>=3;    //>>=3    -- nalezy przesunac trzy bity w prawo poniewaz jeden bit zarezerwowany jest na zajetosc
  Addata &=0xFFF;  //usuniecie smieci i wartosci odczytanej z bitu zajetosci
  CS_H;
  return Addata;  
}


