#include "stm32f10x.h"
#include "fonts.h"



const uint8_t font1[];				//Tahoma 16 bold
const uint16_t font1desc[];
const uint8_t fontinfo1[];   
const uint8_t font2[];			//Verdena 12 Bold
const uint16_t font2desc[];
const uint8_t fontinfo2[];
const uint8_t font3[];     //ARIAL BLACK BOLD 22p
const uint16_t font3desc[];
const uint8_t fontinfo3[];


const uint8_t font6[];     //Arial Black 8pt pogrubienie kursywa
const uint16_t font6desc[];
const uint8_t fontinfo6[];

const uint8_t font4[];     //ARIAL 18 PT BOLD
const uint16_t font4desc[];
const uint8_t fontinfo4[];

const uint8_t font5[];     //Arial 36 pt bold
const uint16_t font5desc[];
const uint8_t fontinfo5[];


extern int chosefont, rotate;



 void send_glyph_byte(uint8_t bajt, uint8_t width, uint16_t COLOR, uint16_t BK_COLOR, int X, int Y,uint8_t alpha) {
	uint8_t i;
	for(i=0; i<width; i++ )
	{
		if(bajt&0x80)
		{
				if(!rotate)ILI9341_DrawPixel(Y, X+i, COLOR); else ILI9341_DrawPixel(240-(X+i), Y, COLOR);
		}
		else if(!alpha)
		{
				if(!rotate) ILI9341_DrawPixel(Y, X+i, BK_COLOR); else  ILI9341_DrawPixel(240-(X+i), Y, BK_COLOR);
		}
		
		bajt<<=1;
	}
}



 void send_font_bitmap(int xPixel, int yPixel, uint16_t OFFSET, int glyphHeight, int glyphWidth, uint16_t C, uint16_t BK_C, uint8_t alpha ) {

	uint8_t i, j, k, bajt=0;
	uint16_t p=OFFSET;

	

	
	//**************************************************************************
	//==========================================================================
	//**************************************************************************
	

	for(i=0; i<glyphHeight; i++ ) {
		
		for(j=0, k=0; j<glyphWidth; j+=8, k++) {
			if(chosefont==1)
				{
					bajt = font1[p++];
				}
			if(chosefont==2)
				{
					bajt = font2[p++];
				}	
			if(chosefont==3)
				{
					bajt = font3[p++];
				}	
			if(chosefont==4)
				{
					bajt = font4[p++];
				}
			if(chosefont==5)
				{
					bajt = font5[p++];
				}
			if(chosefont==6)
				{
					bajt = font6[p++];
				}


			if( ((k+1)*8)<=glyphWidth ) send_glyph_byte(bajt, 8, C, BK_C, xPixel+j, yPixel+i, alpha);
			else send_glyph_byte(bajt, glyphWidth-(k*8), C, BK_C, xPixel+j, yPixel+i, alpha);


		}
	}
}






void tft_mputs( int x, int y, char * s, uint16_t color, uint16_t bk_color, uint8_t alpha ) {

	uint8_t gH, gW, gS, gIS;
	uint16_t offset;
	uint8_t startChar;

	if(chosefont==1)
	{
	startChar = fontinfo1[1];
	gH = fontinfo1[0];
	gIS = fontinfo1[2];
	gS = fontinfo1[3];
	}
	if(chosefont==2)
	{
	startChar = fontinfo2[1];
	gH = fontinfo2[0];
	gIS = fontinfo2[2];
	gS = fontinfo2[3];
	}
	if(chosefont==3)
	{
	startChar = fontinfo3[1];
	gH = fontinfo3[0];
	gIS = fontinfo3[2];
	gS = fontinfo3[3];
	}
	if(chosefont==4)
	{
	startChar = fontinfo4[1];
	gH = fontinfo4[0];
	gIS = fontinfo4[2];
	gS = fontinfo4[3];
	}
	if(chosefont==5)
	{
	startChar = fontinfo5[1];
	gH = fontinfo5[0];
	gIS = fontinfo5[2];
	gS = fontinfo5[3];
	}
	if(chosefont==6)
	{
	startChar = fontinfo6[1];
	gH = fontinfo6[0];
	gIS = fontinfo6[2];
	gS = fontinfo6[3];
	}

	while( *s ) {
		if( *s > ' ') {
			//jezeli zostala wybrana pierwsza czcionka , druga itd
							if(chosefont==1)
											{
													gW=23;
													offset=font1desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;
											}
							if(chosefont==2)
											{
													gW=18;
													offset=font2desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;					
											}
							if(chosefont==3)
											{
													gW=26;
													offset=font3desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;					
											}
							if(chosefont==4)
											{
													gW=23;
													offset=font4desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;
											}
							if(chosefont==5)
											{
													gW=33;
													offset=font5desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;
											}
							if(chosefont==6)
											{
													gW=12;
													offset=font6desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;
											}
			
			
		} else 
	{
			x+=gS;
		}
		s++;
	}
}	

	
	


const uint8_t font1[] = 
{
	     // @0   [!]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @75   ["]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0x44, 0x00,  //            #   #             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @150   [#]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x31, 0x80,  //             ##   ##          //
	     0x00, 0x31, 0x80,  //             ##   ##          //
	     0x00, 0x63, 0x00,  //            ##   ##           //
	     0x00, 0x63, 0x00,  //            ##   ##           //
	     0x07, 0xFF, 0xE0,  //        ##############        //
	     0x07, 0xFF, 0xE0,  //        ##############        //
	     0x00, 0xC6, 0x00,  //           ##   ##            //
	     0x00, 0xC6, 0x00,  //           ##   ##            //
	     0x00, 0xC6, 0x00,  //           ##   ##            //
	     0x00, 0xC6, 0x00,  //           ##   ##            //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x01, 0x8C, 0x00,  //          ##   ##             //
	     0x01, 0x8C, 0x00,  //          ##   ##             //
	     0x03, 0x18, 0x00,  //         ##   ##              //
	     0x03, 0x18, 0x00,  //         ##   ##              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @225   [$]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xD9, 0x00,  //         #### ##  #           //
	     0x03, 0xD8, 0x00,  //         #### ##              //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x00, 0x37, 0x80,  //             ## ####          //
	     0x02, 0x37, 0x80,  //         #   ## ####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x30, 0x00,  //             ##               //

	     // @300   [%]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x3E, 0x01, 0x80,  //     #####        ##          //
	     0x7F, 0x03, 0x00,  //    #######      ##           //
	     0xE3, 0x87, 0x00,  //   ###   ###    ###           //
	     0xE3, 0x86, 0x00,  //   ###   ###    ##            //
	     0xE3, 0x8E, 0x00,  //   ###   ###   ###            //
	     0xE3, 0x8C, 0x00,  //   ###   ###   ##             //
	     0xE3, 0x98, 0xF8,  //   ###   ###  ##   #####      //
	     0xE3, 0x99, 0xFC,  //   ###   ###  ##  #######     //
	     0x7F, 0x33, 0x8E,  //    #######  ##  ###   ###    //
	     0x3E, 0x33, 0x8E,  //     #####   ##  ###   ###    //
	     0x00, 0x63, 0x8E,  //            ##   ###   ###    //
	     0x00, 0xE3, 0x8E,  //           ###   ###   ###    //
	     0x00, 0xC3, 0x8E,  //           ##    ###   ###    //
	     0x01, 0xC3, 0x8E,  //          ###    ###   ###    //
	     0x01, 0x81, 0xFC,  //          ##      #######     //
	     0x03, 0x00, 0xF8,  //         ##        #####      //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @375   [&]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xF0, 0x00,  //         ######               //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x0F, 0xFC, 0x00,  //       ##########             //
	     0x0F, 0x3C, 0x00,  //       ####  ####             //
	     0x0F, 0x3C, 0x00,  //       ####  ####             //
	     0x0F, 0xB8, 0x00,  //       ##### ###              //
	     0x07, 0xF0, 0x00,  //        #######               //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x0F, 0xF7, 0x80,  //       ######## ####          //
	     0x1E, 0xFF, 0x80,  //      #### #########          //
	     0x1E, 0x7F, 0x80,  //      ####  ########          //
	     0x1E, 0x3F, 0x00,  //      ####   ######           //
	     0x1F, 0x1F, 0x00,  //      #####   #####           //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x03, 0xF3, 0xE0,  //         ######  #####        //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @450   [']   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x10, 0x00,  //              #               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @525   [(]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x1E, 0x00,  //              ####            //

	     // @600   [)]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xE0, 0x00,  //          ####                //

	     // @675   [*]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x01, 0x32, 0x00,  //          #  ##  #            //
	     0x03, 0xB7, 0x00,  //         ### ## ###           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xB7, 0x00,  //         ### ## ###           //
	     0x01, 0x32, 0x00,  //          #  ##  #            //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @750   [+]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @825   [,]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x60, 0x00,  //            ##                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xC0, 0x00,  //           ##                 //

	     // @900   [-]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @975   [.]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1050   [/]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x00, 0x00, 0x00,  //                              //

	     // @1125   [0]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1200   [1]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1275   [2]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x02, 0x1F, 0x00,  //         #    #####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1350   [3]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0x07, 0x80,  //         ##     ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x03, 0x0F, 0x80,  //         ##    #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1425   [4]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xDE, 0x00,  //           ## ####            //
	     0x01, 0x9E, 0x00,  //          ##  ####            //
	     0x01, 0x9E, 0x00,  //          ##  ####            //
	     0x03, 0x1E, 0x00,  //         ##   ####            //
	     0x06, 0x1E, 0x00,  //        ##    ####            //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1500   [5]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x02, 0x0F, 0x80,  //         #     #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1575   [6]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3F, 0x00,  //             ######           //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x03, 0xDE, 0x00,  //         #### ####            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xCF, 0x80,  //         ####  #####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xEF, 0x80,  //          #### #####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1650   [7]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1725   [8]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xCF, 0x80,  //          ###  #####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1800   [9]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xEF, 0x00,  //         ##### ####           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1875   [:]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1950   [;]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x60, 0x00,  //            ##                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xC0, 0x00,  //           ##                 //

	     // @2025   [<]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x40,  //                    #         //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x00, 0x0F, 0xC0,  //               ######         //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x07, 0xF0, 0x00,  //        #######               //
	     0x07, 0xC0, 0x00,  //        #####                 //
	     0x07, 0xF0, 0x00,  //        #######               //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x00, 0x0F, 0xC0,  //               ######         //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x00, 0x00, 0x40,  //                    #         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2100   [=]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2175   [>]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x04, 0x00, 0x00,  //        #                     //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x1F, 0xC0,  //              #######         //
	     0x00, 0x07, 0xC0,  //                #####         //
	     0x00, 0x1F, 0xC0,  //              #######         //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x04, 0x00, 0x00,  //        #                     //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2250   [?]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x02, 0x1F, 0x00,  //         #    #####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2325   [@]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0x83, 0xC0,  //         ###     ####         //
	     0x06, 0x00, 0xC0,  //        ##         ##         //
	     0x0C, 0x7E, 0x60,  //       ##   ######  ##        //
	     0x0C, 0xFE, 0x70,  //       ##  #######  ###       //
	     0x18, 0xC6, 0x30,  //      ##   ##   ##   ##       //
	     0x19, 0x86, 0x30,  //      ##  ##    ##   ##       //
	     0x19, 0x86, 0x30,  //      ##  ##    ##   ##       //
	     0x19, 0x86, 0x30,  //      ##  ##    ##   ##       //
	     0x19, 0x86, 0x30,  //      ##  ##    ##   ##       //
	     0x19, 0xC6, 0x70,  //      ##  ###   ##  ###       //
	     0x0C, 0xFF, 0xE0,  //       ##  ###########        //
	     0x0C, 0x7F, 0xE0,  //       ##   ##########        //
	     0x06, 0x00, 0x00,  //        ##                    //
	     0x07, 0x82, 0x00,  //        ####     #            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2400   [A]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2475   [B]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2550   [C]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE1, 0x80,  //         #####    ##          //
	     0x03, 0xC0, 0x80,  //         ####      #          //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x03, 0xC0, 0x80,  //         ####      #          //
	     0x03, 0xE1, 0x80,  //         #####    ##          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2625   [D]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2700   [E]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2775   [F]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2850   [G]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x01, 0xFF, 0xC0,  //          ###########         //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x07, 0xC1, 0xC0,  //        #####     ###         //
	     0x07, 0x80, 0x40,  //        ####        #         //
	     0x0F, 0x00, 0x00,  //       ####                   //
	     0x0F, 0x00, 0x00,  //       ####                   //
	     0x0F, 0x1F, 0xC0,  //       ####   #######         //
	     0x0F, 0x1F, 0xC0,  //       ####   #######         //
	     0x0F, 0x1F, 0xC0,  //       ####   #######         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0xC3, 0xC0,  //        #####    ####         //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x01, 0xFF, 0xC0,  //          ###########         //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2925   [H]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3000   [I]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3075   [J]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x02, 0x1F, 0x00,  //         #    #####           //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3150   [K]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x87, 0xC0,  //        ####    #####         //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0xBE, 0x00,  //        #### #####            //
	     0x07, 0xBC, 0x00,  //        #### ####             //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xBE, 0x00,  //        #### #####            //
	     0x07, 0x9E, 0x00,  //        ####  ####            //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x8F, 0x00,  //        ####   ####           //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0xC0,  //        ####    #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3225   [L]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3300   [M]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0x83, 0xE0,  //       #####     #####        //
	     0x0F, 0x83, 0xE0,  //       #####     #####        //
	     0x0F, 0xC3, 0xE0,  //       ######    #####        //
	     0x0F, 0xC7, 0xE0,  //       ######   ######        //
	     0x0F, 0xC7, 0xE0,  //       ######   ######        //
	     0x0F, 0xEF, 0xE0,  //       ####### #######        //
	     0x0F, 0xEF, 0xE0,  //       ####### #######        //
	     0x0F, 0x7D, 0xE0,  //       #### ##### ####        //
	     0x0F, 0x7D, 0xE0,  //       #### ##### ####        //
	     0x0F, 0x7D, 0xE0,  //       #### ##### ####        //
	     0x0F, 0x39, 0xE0,  //       ####  ###  ####        //
	     0x0F, 0x39, 0xE0,  //       ####  ###  ####        //
	     0x0F, 0x01, 0xE0,  //       ####       ####        //
	     0x0F, 0x01, 0xE0,  //       ####       ####        //
	     0x0F, 0x01, 0xE0,  //       ####       ####        //
	     0x0F, 0x01, 0xE0,  //       ####       ####        //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3375   [N]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xC7, 0x80,  //        #####   ####          //
	     0x07, 0xC7, 0x80,  //        #####   ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xF7, 0x80,  //        ####### ####          //
	     0x07, 0xB7, 0x80,  //        #### ## ####          //
	     0x07, 0xB7, 0x80,  //        #### ## ####          //
	     0x07, 0xBF, 0x80,  //        #### #######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3450   [O]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3525   [P]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3600   [Q]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1F, 0xC0,  //              #######         //
	     0x00, 0x0F, 0xC0,  //               ######         //
	     0x00, 0x07, 0xC0,  //                #####         //

	     // @3675   [R]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0x8F, 0x00,  //        ####   ####           //
	     0x07, 0x8F, 0x00,  //        ####   ####           //
	     0x07, 0x8F, 0x00,  //        ####   ####           //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xBC, 0x00,  //        #### ####             //
	     0x07, 0xBE, 0x00,  //        #### #####            //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0xC0,  //        ####    #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3750   [S]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC3, 0x00,  //         ####    ##           //
	     0x03, 0xC1, 0x00,  //         ####     #           //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x02, 0x07, 0x80,  //         #      ####          //
	     0x03, 0x07, 0x80,  //         ##     ####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3825   [T]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3900   [U]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3975   [V]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4050   [W]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0xF0, 0x78, 0x3C,  //   ####     ####     ####     //
	     0xF0, 0x78, 0x3C,  //   ####     ####     ####     //
	     0x78, 0xFC, 0x78,  //    ####   ######   ####      //
	     0x78, 0xFC, 0x78,  //    ####   ######   ####      //
	     0x78, 0xFC, 0x78,  //    ####   ######   ####      //
	     0x78, 0xFC, 0x78,  //    ####   ######   ####      //
	     0x39, 0xFE, 0xF0,  //     ###  ######## ####       //
	     0x3D, 0xFE, 0xF0,  //     #### ######## ####       //
	     0x3D, 0xCE, 0xF0,  //     #### ###  ### ####       //
	     0x3D, 0xCE, 0xF0,  //     #### ###  ### ####       //
	     0x1F, 0xCF, 0xE0,  //      #######  #######        //
	     0x1F, 0xCF, 0xE0,  //      #######  #######        //
	     0x1F, 0x87, 0xE0,  //      ######    ######        //
	     0x1F, 0x87, 0xE0,  //      ######    ######        //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4125   [X]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4200   [Y]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4275   [Z]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4350   [[]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //

	     // @4425   [\]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x00, 0x00,  //                              //

	     // @4500   []]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //

	     // @4575   [^]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0x8E, 0x00,  //         ###   ###            //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4650   [_]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x00, 0x00,  //                              //

	     // @4725   [`]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4800   [a]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x7F, 0x80,  //            ########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4875   [b]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xDE, 0x00,  //         #### ####            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xCF, 0x80,  //         ####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4950   [c]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xF1, 0x00,  //          #####   #           //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xF1, 0x00,  //          #####   #           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5025   [d]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x77, 0x80,  //            ### ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5100   [e]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xE1, 0x00,  //         #####    #           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5175   [f]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5250   [g]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7F, 0x80,  //            ########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFC, 0x00,  //          #######             //

	     // @5325   [h]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xCE, 0x00,  //         ####  ###            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5400   [i]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5475   [j]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xF8, 0x00,  //           #####              //

	     // @5550   [k]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x9E, 0x00,  //        ####  ####            //
	     0x07, 0xBC, 0x00,  //        #### ####             //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xBC, 0x00,  //        #### ####             //
	     0x07, 0xBE, 0x00,  //        #### #####            //
	     0x07, 0x9E, 0x00,  //        ####  ####            //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5625   [l]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5700   [m]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x3C, 0xE1, 0xC0,  //     ####  ###    ###         //
	     0x3F, 0xF7, 0xE0,  //     ########## ######        //
	     0x3F, 0xFF, 0xF0,  //     ##################       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5775   [n]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xCE, 0x00,  //         ####  ###            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5850   [o]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xEF, 0x80,  //         ##### #####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xEF, 0x80,  //         ##### #####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5925   [p]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xDE, 0x00,  //         #### ####            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xCF, 0x80,  //         ####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xDC, 0x00,  //         #### ###             //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //

	     // @6000   [q]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x77, 0x80,  //            ### ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //

	     // @6075   [r]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xE6, 0x00,  //          ####  ##            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6150   [s]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xE1, 0x00,  //          ####    #           //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x01, 0x0F, 0x00,  //          #    ####           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6225   [t]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6300   [u]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6375   [v]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x01, 0xEE, 0x00,  //          #### ###            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6450   [w]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x3C, 0x38, 0x78,  //     ####    ###    ####      //
	     0x3C, 0x3C, 0x78,  //     ####    ####   ####      //
	     0x1E, 0x7C, 0xF0,  //      ####  #####  ####       //
	     0x1E, 0x7C, 0xF0,  //      ####  #####  ####       //
	     0x1E, 0x6C, 0xF0,  //      ####  ## ##  ####       //
	     0x0E, 0xEE, 0xE0,  //       ### ### ### ###        //
	     0x0E, 0xEE, 0xE0,  //       ### ### ### ###        //
	     0x0F, 0xEF, 0xE0,  //       ####### #######        //
	     0x0F, 0xC7, 0xE0,  //       ######   ######        //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6525   [x]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6600   [y]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xE0, 0x00,  //          ####                //

	     // @6675   [z]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6750   [{]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x0F, 0x80,  //               #####          //

	     // @6825   [|]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //

	     // @6900   [}]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xF0, 0x00,  //         ######               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x03, 0xF0, 0x00,  //         ######               //
	     0x03, 0xE0, 0x00,  //         #####                //

	     // @6975   [~]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xC0, 0xE0,  //         ####      ###        //
	     0x07, 0xF0, 0xE0,  //        #######    ###        //
	     0x07, 0xF8, 0xE0,  //        ########   ###        //
	     0x0F, 0x3D, 0xE0,  //       ####  #### ####        //
	     0x0E, 0x3F, 0xC0,  //       ###   ########         //
	     0x0E, 0x1F, 0xC0,  //       ###    #######         //
	     0x0E, 0x0F, 0x80,  //       ###     #####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7050   [Ĺš]   (23 px wide)
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC3, 0x00,  //         ####    ##           //
	     0x03, 0xC1, 0x00,  //         ####     #           //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x02, 0x07, 0x80,  //         #      ####          //
	     0x03, 0x07, 0x80,  //         ##     ####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7125   [Ĺą]   (23 px wide)
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7200   [Ĺ›]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xE1, 0x00,  //          ####    #           //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x01, 0x0F, 0x00,  //          #    ####           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7275   [Ĺş]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7350   [Ĺ�]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE4, 0x00,  //          ####  #             //
	     0x01, 0xEC, 0x00,  //          #### ##             //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x05, 0xE0, 0x00,  //        # ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7425   [Ä„]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x03, 0x80,  //                 ###          //

	     // @7500   [Ĺ»]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7575   [Ĺ‚]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x7A, 0x00,  //            #### #            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x01, 0x78, 0x00,  //          # ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7650   [Ä…]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x7F, 0x80,  //            ########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x03, 0x80,  //                 ###          //

	     // @7725   [ĹĽ]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7800   [Ä†]   (23 px wide)
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE1, 0x80,  //         #####    ##          //
	     0x03, 0xC0, 0x80,  //         ####      #          //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x03, 0xC0, 0x80,  //         ####      #          //
	     0x03, 0xE1, 0x80,  //         #####    ##          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7875   [Ä�]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x07, 0x00,  //                ###           //

	     // @7950   [Ĺ�]   (23 px wide)
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xC7, 0x80,  //        #####   ####          //
	     0x07, 0xC7, 0x80,  //        #####   ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xF7, 0x80,  //        ####### ####          //
	     0x07, 0xB7, 0x80,  //        #### ## ####          //
	     0x07, 0xB7, 0x80,  //        #### ## ####          //
	     0x07, 0xBF, 0x80,  //        #### #######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8025   [Ă“]   (23 px wide)
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8100   [Ä‡]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xF1, 0x00,  //          #####   #           //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xF1, 0x00,  //          #####   #           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8175   [Ä™]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xE1, 0x00,  //         #####    #           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x0C, 0x00,  //               ##             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x0E, 0x00,  //               ###            //

	     // @8250   [Ĺ„]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xCE, 0x00,  //         ####  ###            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8325   [Ăł]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xEF, 0x80,  //         ##### #####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xEF, 0x80,  //         ##### #####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
};
 

const uint16_t font1desc[]=
{
		   0 ,		// !  (33)
		   75 ,		// "  (34)
		   150 ,		// #  (35)
		   225 ,		// $  (36)
		   300 ,		// %  (37)
		   375 ,		// &  (38)
		   450 ,		// '  (39)
		   525 ,		// (  (40)
		   600 ,		// )  (41)
		   675 ,		// *  (42)
		   750 ,		// +  (43)
		   825 ,		// ,  (44)
		   900 ,		// -  (45)
		   975 ,		// .  (46)
		   1050 ,		// /  (47)
		   1125 ,		// 0  (48)
		   1200 ,		// 1  (49)
		   1275 ,		// 2  (50)
		   1350 ,		// 3  (51)
		   1425 ,		// 4  (52)
		   1500 ,		// 5  (53)
		   1575 ,		// 6  (54)
		   1650 ,		// 7  (55)
		   1725 ,		// 8  (56)
		   1800 ,		// 9  (57)
		   1875 ,		// :  (58)
		   1950 ,		// ;  (59)
		   2025 ,		// <  (60)
		   2100 ,		// =  (61)
		   2175 ,		// >  (62)
		   2250 ,		// ?  (63)
		   2325 ,		// @  (64)
		   2400 ,		// A  (65)
		   2475 ,		// B  (66)
		   2550 ,		// C  (67)
		   2625 ,		// D  (68)
		   2700 ,		// E  (69)
		   2775 ,		// F  (70)
		   2850 ,		// G  (71)
		   2925 ,		// H  (72)
		   3000 ,		// I  (73)
		   3075 ,		// J  (74)
		   3150 ,		// K  (75)
		   3225 ,		// L  (76)
		   3300 ,		// M  (77)
		   3375 ,		// N  (78)
		   3450 ,		// O  (79)
		   3525 ,		// P  (80)
		   3600 ,		// Q  (81)
		   3675 ,		// R  (82)
		   3750 ,		// S  (83)
		   3825 ,		// T  (84)
		   3900 ,		// U  (85)
		   3975 ,		// V  (86)
		   4050 ,		// W  (87)
		   4125 ,		// X  (88)
		   4200 ,		// Y  (89)
		   4275 ,		// Z  (90)
		   4350 ,		// [  (91)
		   4425 ,		// //  (92)
		   4500 ,		// ]  (93)
		   4575 ,		// ^  (94)
		   4650 ,		// _  (95)
		   4725 ,		// `  (96)
		   4800 ,		// a  (97)
		   4875 ,		// b  (98)
		   4950 ,		// c  (99)
		   5025 ,		// d  (100)
		   5100 ,		// e  (101)
		   5175 ,		// f  (102)
		   5250 ,		// g  (103)
		   5325 ,		// h  (104)
		   5400 ,		// i  (105)
		   5475 ,		// j  (106)
		   5550 ,		// k  (107)
		   5625 ,		// l  (108)
		   5700 ,		// m  (109)
		   5775 ,		// n  (110)
		   5850 ,		// o  (111)
		   5925 ,		// p  (112)
		   6000 ,		// q  (113)
		   6075 ,		// r  (114)
		   6150 ,		// s  (115)
		   6225 ,		// t  (116)
		   6300 ,		// u  (117)
		   6375 ,		// v  (118)
		   6450 ,		// w  (119)
		   6525 ,		// x  (120)
		   6600 ,		// y  (121)
		   6675 ,		// z  (122)
		   6750 ,		// {  (123)
		   6825 ,		// |  (124)
		   6900 ,		// }  (125)
		   6975 ,		// ~  (126)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7050 ,		// Ĺš  (140)
		   0 ,		//
		   0 ,		//
		   7125 ,		// Ĺą  (143)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7200 ,		// Ĺ›  (156)
		   0 ,		//
		   0 ,		//
		   7275 ,		// Ĺş  (159)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7350 ,		// Ĺ�  (163)
		   0 ,		//
		   7425 ,		// Ä„  (165)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7500 ,		// Ĺ»  (175)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7575 ,		// Ĺ‚  (179)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7650 ,		// Ä…  (185)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7725 ,		// ĹĽ  (191)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7800 ,		// Ä†  (198)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    7875 ,		// Ä�  (202)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    7950 ,		// Ĺ�  (209)
		    0 ,		//
		    8025 ,		// Ă“  (211)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    8100 ,		// Ä‡  (230)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    8175 ,		// Ä™  (234)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    8250 ,		// Ĺ„  (241)
		    0 ,		//
		    8325 		// Ăł  (243)
};
 


 


// informacje Arial Black 72
const uint8_t fontinfo1[] =
{
	    25,  // Character height
	    '!',  //  Start character
	    0,  //  number of pixels of interspace between characters
	    0,  // number of pixels of space character


};
//*************************************************************************************
//druga czcionka
const uint8_t font2[] = 
{
		  // @0   [!]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @54   ["]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @108   [#]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0x08, 0x00,  //          #    #         //
		     0x01, 0x08, 0x00,  //          #    #         //
		     0x02, 0x10, 0x00,  //         #    #          //
		     0x0F, 0xFC, 0x00,  //       ##########        //
		     0x0F, 0xFC, 0x00,  //       ##########        //
		     0x02, 0x10, 0x00,  //         #    #          //
		     0x04, 0x20, 0x00,  //        #    #           //
		     0x1F, 0xF8, 0x00,  //      ##########         //
		     0x1F, 0xF8, 0x00,  //      ##########         //
		     0x04, 0x20, 0x00,  //        #    #           //
		     0x08, 0x40, 0x00,  //       #    #            //
		     0x08, 0x40, 0x00,  //       #    #            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @162   [$]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x06, 0x98, 0x00,  //        ## #  ##         //
		     0x0C, 0x98, 0x00,  //       ##  #  ##         //
		     0x0C, 0x80, 0x00,  //       ##  #             //
		     0x0C, 0x80, 0x00,  //       ##  #             //
		     0x07, 0xF0, 0x00,  //        #######          //
		     0x00, 0x98, 0x00,  //           #  ##         //
		     0x00, 0x98, 0x00,  //           #  ##         //
		     0x0C, 0x98, 0x00,  //       ##  #  ##         //
		     0x0C, 0xB0, 0x00,  //       ##  # ##          //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x00, 0x00,  //                         //

		     // @216   [%]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x7C, 0x10, 0x00,  //    #####     #          //
		     0xC6, 0x10, 0x00,  //   ##   ##    #          //
		     0xC6, 0x20, 0x00,  //   ##   ##   #           //
		     0xC6, 0x20, 0x00,  //   ##   ##   #           //
		     0xC6, 0x40, 0x00,  //   ##   ##  #            //
		     0xC6, 0x4F, 0x80,  //   ##   ##  #  #####     //
		     0x7C, 0x98, 0xC0,  //    #####  #  ##   ##    //
		     0x00, 0x98, 0xC0,  //           #  ##   ##    //
		     0x01, 0x18, 0xC0,  //          #   ##   ##    //
		     0x01, 0x18, 0xC0,  //          #   ##   ##    //
		     0x02, 0x18, 0xC0,  //         #    ##   ##    //
		     0x02, 0x0F, 0x80,  //         #     #####     //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @270   [&]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xC0, 0x00,  //        #####            //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x06, 0xCC, 0x00,  //        ## ##  ##        //
		     0x07, 0x8C, 0x00,  //        ####   ##        //
		     0x0C, 0xCC, 0x00,  //       ##  ##  ##        //
		     0x18, 0x68, 0x00,  //      ##    ## #         //
		     0x18, 0x38, 0x00,  //      ##     ###         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x0C, 0x2C, 0x00,  //       ##    # ##        //
		     0x07, 0xC6, 0x00,  //        #####   ##       //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @324   [']   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @378   [(]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x30, 0x00,  //             ##          //

		     // @432   [)]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //

		     // @486   [*]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x80, 0x00,  //           #             //
		     0x04, 0x90, 0x00,  //        #  #  #          //
		     0x02, 0xA0, 0x00,  //         # # #           //
		     0x01, 0xC0, 0x00,  //          ###            //
		     0x01, 0xC0, 0x00,  //          ###            //
		     0x02, 0xA0, 0x00,  //         # # #           //
		     0x04, 0x90, 0x00,  //        #  #  #          //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @540   [+]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @594   [,]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xE0, 0x00,  //           ###           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //

		     // @648   [-]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @702   [.]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @756   [/]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //

		     // @810   [0]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @864   [1]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x03, 0xC0, 0x00,  //         ####            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @918   [2]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @972   [3]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1026   [4]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x70, 0x00,  //            ###          //
		     0x00, 0xB0, 0x00,  //           # ##          //
		     0x01, 0x30, 0x00,  //          #  ##          //
		     0x02, 0x30, 0x00,  //         #   ##          //
		     0x04, 0x30, 0x00,  //        #    ##          //
		     0x08, 0x30, 0x00,  //       #     ##          //
		     0x0F, 0xFC, 0x00,  //       ##########        //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1080   [5]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1134   [6]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xF0, 0x00,  //           ####          //
		     0x03, 0x80, 0x00,  //         ###             //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1188   [7]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1242   [8]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1296   [9]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0xE0, 0x00,  //           ###           //
		     0x07, 0x80, 0x00,  //        ####             //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1350   [:]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1404   [;]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xE0, 0x00,  //           ###           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //

		     // @1458   [<]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x08, 0x00,  //               #         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x08, 0x00,  //               #         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1512   [=]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1566   [>]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x08, 0x00, 0x00,  //       #                 //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x08, 0x00, 0x00,  //       #                 //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1620   [?]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1674   [@]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x10, 0x04, 0x00,  //      #         #        //
		     0x11, 0xF4, 0x00,  //      #   ##### #        //
		     0x23, 0x32, 0x00,  //     #   ##  ##  #       //
		     0x26, 0x32, 0x00,  //     #  ##   ##  #       //
		     0x26, 0x32, 0x00,  //     #  ##   ##  #       //
		     0x26, 0x32, 0x00,  //     #  ##   ##  #       //
		     0x26, 0x32, 0x00,  //     #  ##   ##  #       //
		     0x26, 0x72, 0x00,  //     #  ##  ###  #       //
		     0x13, 0xBC, 0x00,  //      #  ### ####        //
		     0x10, 0x00, 0x00,  //      #                  //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //

		     // @1728   [A]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1782   [B]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xE0, 0x00,  //       #######           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x10, 0x00,  //       ##     #          //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1836   [C]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xF8, 0x00,  //          ######         //
		     0x07, 0x0C, 0x00,  //        ###    ##        //
		     0x06, 0x0C, 0x00,  //        ##     ##        //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x06, 0x0C, 0x00,  //        ##     ##        //
		     0x07, 0x0C, 0x00,  //        ###    ##        //
		     0x01, 0xF8, 0x00,  //          ######         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1890   [D]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x1F, 0xE0, 0x00,  //      ########           //
		     0x18, 0x38, 0x00,  //      ##     ###         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x38, 0x00,  //      ##     ###         //
		     0x1F, 0xE0, 0x00,  //      ########           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1944   [E]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1998   [F]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2052   [G]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF8, 0x00,  //         #######         //
		     0x0E, 0x0C, 0x00,  //       ###     ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x18, 0x00, 0x00,  //      ##                 //
		     0x18, 0x00, 0x00,  //      ##                 //
		     0x18, 0x00, 0x00,  //      ##                 //
		     0x18, 0x7C, 0x00,  //      ##    #####        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0E, 0x0C, 0x00,  //       ###     ##        //
		     0x03, 0xF8, 0x00,  //         #######         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2106   [H]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x1F, 0xFC, 0x00,  //      ###########        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2160   [I]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2214   [J]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x07, 0xC0, 0x00,  //        #####            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2268   [K]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0xC0, 0x00,  //       ##  ##            //
		     0x0D, 0x80, 0x00,  //       ## ##             //
		     0x0F, 0x80, 0x00,  //       #####             //
		     0x0E, 0xC0, 0x00,  //       ### ##            //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2322   [L]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2376   [M]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x30, 0x0E, 0x00,  //     ##        ###       //
		     0x38, 0x0E, 0x00,  //     ###       ###       //
		     0x38, 0x1E, 0x00,  //     ###      ####       //
		     0x2C, 0x16, 0x00,  //     # ##     # ##       //
		     0x2C, 0x36, 0x00,  //     # ##    ## ##       //
		     0x26, 0x26, 0x00,  //     #  ##   #  ##       //
		     0x26, 0x66, 0x00,  //     #  ##  ##  ##       //
		     0x23, 0x46, 0x00,  //     #   ## #   ##       //
		     0x23, 0xC6, 0x00,  //     #   ####   ##       //
		     0x21, 0x86, 0x00,  //     #    ##    ##       //
		     0x21, 0x86, 0x00,  //     #    ##    ##       //
		     0x20, 0x06, 0x00,  //     #          ##       //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2430   [N]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x1C, 0x04, 0x00,  //      ###       #        //
		     0x1C, 0x04, 0x00,  //      ###       #        //
		     0x16, 0x04, 0x00,  //      # ##      #        //
		     0x13, 0x04, 0x00,  //      #  ##     #        //
		     0x11, 0x84, 0x00,  //      #   ##    #        //
		     0x11, 0x84, 0x00,  //      #   ##    #        //
		     0x10, 0xC4, 0x00,  //      #    ##   #        //
		     0x10, 0x64, 0x00,  //      #     ##  #        //
		     0x10, 0x64, 0x00,  //      #     ##  #        //
		     0x10, 0x34, 0x00,  //      #      ## #        //
		     0x10, 0x1C, 0x00,  //      #       ###        //
		     0x10, 0x1C, 0x00,  //      #       ###        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2484   [O]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2538   [P]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2592   [Q]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x70, 0x00,  //            ###          //
		     0x00, 0x3E, 0x00,  //             #####       //

		     // @2646   [R]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x1F, 0xE0, 0x00,  //      ########           //
		     0x18, 0x30, 0x00,  //      ##     ##          //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x30, 0x00,  //      ##     ##          //
		     0x1F, 0xE0, 0x00,  //      ########           //
		     0x18, 0xC0, 0x00,  //      ##   ##            //
		     0x18, 0x60, 0x00,  //      ##    ##           //
		     0x18, 0x30, 0x00,  //      ##     ##          //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2700   [S]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0E, 0x00, 0x00,  //       ###               //
		     0x07, 0xC0, 0x00,  //        #####            //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x00, 0x38, 0x00,  //             ###         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2754   [T]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xFC, 0x00,  //       ##########        //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2808   [U]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x07, 0xF0, 0x00,  //        #######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2862   [V]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2916   [W]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x60, 0xC1, 0x80,  //    ##     ##     ##     //
		     0x60, 0xC1, 0x80,  //    ##     ##     ##     //
		     0x60, 0xC1, 0x80,  //    ##     ##     ##     //
		     0x31, 0xE3, 0x00,  //     ##   ####   ##      //
		     0x31, 0x23, 0x00,  //     ##   #  #   ##      //
		     0x33, 0x33, 0x00,  //     ##  ##  ##  ##      //
		     0x1B, 0x36, 0x00,  //      ## ##  ## ##       //
		     0x1A, 0x16, 0x00,  //      ## #    # ##       //
		     0x1E, 0x1E, 0x00,  //      ####    ####       //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2970   [X]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3024   [Y]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3078   [Z]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3132   [[]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0xE0, 0x00,  //         #####           //

		     // @3186   [\]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //

		     // @3240   []]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x03, 0xE0, 0x00,  //         #####           //

		     // @3294   [^]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x80, 0x00,  //           #             //
		     0x01, 0xC0, 0x00,  //          ###            //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3348   [_]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x1F, 0xFC, 0x00,  //      ###########        //
		     0x00, 0x00, 0x00,  //                         //

		     // @3402   [`]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3456   [a]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x01, 0xF8, 0x00,  //          ######         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x38, 0x00,  //       ##    ###         //
		     0x07, 0xD8, 0x00,  //        ##### ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3510   [b]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3564   [c]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x03, 0x18, 0x00,  //         ##   ##         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x03, 0x18, 0x00,  //         ##   ##         //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3618   [d]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3672   [e]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3726   [f]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xF0, 0x00,  //           ####          //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3780   [g]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //

		     // @3834   [h]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3888   [i]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3942   [j]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x03, 0xC0, 0x00,  //         ####            //

		     // @3996   [k]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0xC0, 0x00,  //       ##  ##            //
		     0x0D, 0x80, 0x00,  //       ## ##             //
		     0x0F, 0x80, 0x00,  //       #####             //
		     0x0E, 0xC0, 0x00,  //       ### ##            //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4050   [l]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4104   [m]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x37, 0x9E, 0x00,  //     ## ####  ####       //
		     0x38, 0xE3, 0x00,  //     ###   ###   ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4158   [n]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4212   [o]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4266   [p]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //

		     // @4320   [q]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //

		     // @4374   [r]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x06, 0x70, 0x00,  //        ##  ###          //
		     0x06, 0xF0, 0x00,  //        ## ####          //
		     0x07, 0x00, 0x00,  //        ###              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4428   [s]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0x80, 0x00,  //        ####             //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0xF0, 0x00,  //           ####          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4482   [t]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xF0, 0x00,  //           ####          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4536   [u]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4590   [v]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4644   [w]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x18, 0xC6, 0x00,  //      ##   ##   ##       //
		     0x19, 0xE6, 0x00,  //      ##  ####  ##       //
		     0x19, 0x26, 0x00,  //      ##  #  #  ##       //
		     0x0F, 0x3C, 0x00,  //       ####  ####        //
		     0x0F, 0x3C, 0x00,  //       ####  ####        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4698   [x]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x01, 0xC0, 0x00,  //          ###            //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4752   [y]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //

		     // @4806   [z]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4860   [{]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x78, 0x00,  //            ####         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x07, 0x00, 0x00,  //        ###              //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x78, 0x00,  //            ####         //

		     // @4914   [|]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //

		     // @4968   [}]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0x80, 0x00,  //        ####             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x38, 0x00,  //             ###         //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x07, 0x80, 0x00,  //        ####             //

		     // @5022   [~]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x06, 0x04, 0x00,  //        ##      #        //
		     0x09, 0x04, 0x00,  //       #  #     #        //
		     0x10, 0x84, 0x00,  //      #    #    #        //
		     0x10, 0x48, 0x00,  //      #     #  #         //
		     0x10, 0x30, 0x00,  //      #      ##          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5076   [Ĺš]   (18 px wide)
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0E, 0x00, 0x00,  //       ###               //
		     0x07, 0xC0, 0x00,  //        #####            //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x00, 0x38, 0x00,  //             ###         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5130   [Ĺą]   (18 px wide)
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5184   [Ĺ›]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0x80, 0x00,  //        ####             //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0xF0, 0x00,  //           ####          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5238   [Ĺş]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5292   [Ĺ�]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x40, 0x00,  //        ##  #            //
		     0x06, 0x80, 0x00,  //        ## #             //
		     0x07, 0x00, 0x00,  //        ###              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0E, 0x00, 0x00,  //       ###               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5346   [Ä„]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0xC0, 0x00,  //         ####            //
		     0x03, 0xC0, 0x00,  //         ####            //
		     0x06, 0x60, 0x00,  //        ##  ##           //
		     0x06, 0x60, 0x00,  //        ##  ##           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x00, 0x20, 0x00,  //             #           //
		     0x00, 0x20, 0x00,  //             #           //
		     0x00, 0x1C, 0x00,  //              ###        //

		     // @5400   [Ĺ»]   (18 px wide)
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5454   [Ĺ‚]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xE0, 0x00,  //           ###           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0xC0, 0x00,  //          ###            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5508   [Ä…]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xC0, 0x00,  //        #####            //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x18, 0x30, 0x00,  //      ##     ##          //
		     0x18, 0x30, 0x00,  //      ##     ##          //
		     0x18, 0x70, 0x00,  //      ##    ###          //
		     0x0F, 0xB0, 0x00,  //       ##### ##          //
		     0x00, 0x20, 0x00,  //             #           //
		     0x00, 0x20, 0x00,  //             #           //
		     0x00, 0x1C, 0x00,  //              ###        //

		     // @5562   [ĹĽ]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5616   [Ä†]   (18 px wide)
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xF8, 0x00,  //          ######         //
		     0x07, 0x0C, 0x00,  //        ###    ##        //
		     0x06, 0x0C, 0x00,  //        ##     ##        //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x06, 0x0C, 0x00,  //        ##     ##        //
		     0x07, 0x0C, 0x00,  //        ###    ##        //
		     0x01, 0xF8, 0x00,  //          ######         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5670   [Ä�]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x40, 0x00,  //            #            //
		     0x00, 0x40, 0x00,  //            #            //
		     0x00, 0x38, 0x00,  //             ###         //

		     // @5724   [Ĺ�]   (18 px wide)
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x1C, 0x04, 0x00,  //      ###       #        //
		     0x1C, 0x04, 0x00,  //      ###       #        //
		     0x16, 0x04, 0x00,  //      # ##      #        //
		     0x13, 0x04, 0x00,  //      #  ##     #        //
		     0x11, 0x84, 0x00,  //      #   ##    #        //
		     0x11, 0x84, 0x00,  //      #   ##    #        //
		     0x10, 0xC4, 0x00,  //      #    ##   #        //
		     0x10, 0x64, 0x00,  //      #     ##  #        //
		     0x10, 0x64, 0x00,  //      #     ##  #        //
		     0x10, 0x34, 0x00,  //      #      ## #        //
		     0x10, 0x1C, 0x00,  //      #       ###        //
		     0x10, 0x1C, 0x00,  //      #       ###        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5778   [Ă“]   (18 px wide)
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5832   [Ä‡]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x03, 0x18, 0x00,  //         ##   ##         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x03, 0x18, 0x00,  //         ##   ##         //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5886   [Ä™]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x40, 0x00,  //            #            //
		     0x00, 0x40, 0x00,  //            #            //
		     0x00, 0x38, 0x00,  //             ###         //

		     // @5940   [Ĺ„]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x00, 0x00,  //                         //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5994   [Ăł]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
	 };
//szerokosc 22
	const uint16_t font2desc[]=
{
		     0 ,		// !  (33)
		    54 ,		// "  (34)
		    108 ,		// #  (35)
		    162 ,		// $  (36)
		    216 ,		// %  (37)
		    270 ,		// &  (38)
		    324 ,		// '  (39)
		    378 ,		// (  (40)
		    432 ,		// )  (41)
		    486 ,		// *  (42)
		    540 ,		// +  (43)
		    594 ,		// ,  (44)
		    648 ,		// -  (45)
		    702 ,		// .  (46)
		    756 ,		// /  (47)
		    810 ,		// 0  (48)
		    864 ,		// 1  (49)
		    918 ,		// 2  (50)
		    972 ,		// 3  (51)
		    1026 ,		// 4  (52)
		    1080 ,		// 5  (53)
		    1134 ,		// 6  (54)
		    1188 ,		// 7  (55)
		    1242 ,		// 8  (56)
		    1296 ,		// 9  (57)
		    1350 ,		// :  (58)
		    1404 ,		// ;  (59)
		    1458 ,		// <  (60)
		    1512 ,		// =  (61)
		    1566 ,		// >  (62)
		    1620 ,		// ?  (63)
		    1674 ,		// @  (64)
		    1728 ,		// A  (65)
		    1782 ,		// B  (66)
		    1836 ,		// C  (67)
		    1890 ,		// D  (68)
		    1944 ,		// E  (69)
		    1998 ,		// F  (70)
		    2052 ,		// G  (71)
		    2106 ,		// H  (72)
		    2160 ,		// I  (73)
		    2214 ,		// J  (74)
		    2268 ,		// K  (75)
		    2322 ,		// L  (76)
		    2376 ,		// M  (77)
		    2430 ,		// N  (78)
		    2484 ,		// O  (79)
		    2538 ,		// P  (80)
		    2592 ,		// Q  (81)
		    2646 ,		// R  (82)
		    2700 ,		// S  (83)
		    2754 ,		// T  (84)
		    2808 ,		// U  (85)
		    2862 ,		// V  (86)
		    2916 ,		// W  (87)
		    2970 ,		// X  (88)
		    3024 ,		// Y  (89)
		    3078 ,		// Z  (90)
		    3132 ,		// [  (91)
		    3186 ,		// //  (92)
		    3240 ,		// ]  (93)
		    3294 ,		// ^  (94)
		    3348 ,		// _  (95)
		    3402 ,		// `  (96)
		    3456 ,		// a  (97)
		    3510 ,		// b  (98)
		    3564 ,		// c  (99)
		    3618 ,		// d  (100)
		    3672 ,		// e  (101)
		    3726 ,		// f  (102)
		    3780 ,		// g  (103)
		    3834 ,		// h  (104)
		    3888 ,		// i  (105)
		    3942 ,		// j  (106)
		    3996 ,		// k  (107)
		    4050 ,		// l  (108)
		    4104 ,		// m  (109)
		    4158 ,		// n  (110)
		    4212 ,		// o  (111)
		    4266 ,		// p  (112)
		    4320 ,		// q  (113)
		    4374 ,		// r  (114)
		    4428 ,		// s  (115)
		    4482 ,		// t  (116)
		    4536 ,		// u  (117)
		    4590 ,		// v  (118)
		    4644 ,		// w  (119)
		    4698 ,		// x  (120)
		    4752 ,		// y  (121)
		    4806 ,		// z  (122)
		    4860 ,		// {  (123)
		    4914 ,		// |  (124)
		    4968 ,		// }  (125)
		    5022 ,		// ~  (126)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5076 ,		// Ĺš  (140)
		    0 ,		//
		    0 ,		//
		    5130 ,		// Ĺą  (143)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5184 ,		// Ĺ›  (156)
		    0 ,		//
		    0 ,		//
		    5238 ,		// Ĺş  (159)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5292 ,		// Ĺ�  (163)
		    0 ,		//
		    5346 ,		// Ä„  (165)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5400 ,		// Ĺ»  (175)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5454 ,		// Ĺ‚  (179)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5508 ,		// Ä…  (185)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5562 ,		// ĹĽ  (191)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5616 ,		// Ä†  (198)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5670 ,		// Ä�  (202)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5724 ,		// Ĺ�  (209)
		    0 ,		//
		    5778 ,		// Ă“  (211)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5832 ,		// Ä‡  (230)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5886 ,		// Ä™  (234)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5940 ,		// Ĺ„  (241)
		    0 ,		//
		    5994 		// Ăł  (243)
};

const uint8_t fontinfo2[] =
{
		 18,  // Character height
		    '!',  //  Start character
		    0,  //  number of pixels of interspace between characters
		    18,  // number of pixels of space character

};
//***************************************************************************
//trzecia czcionka
const uint8_t font3[]=
{
		  // @0   [,]   (26 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0x07, 0x00, 0x00,  //                ###              //
		     0x00, 0x07, 0x00, 0x00,  //                ###              //
		     0x00, 0x0E, 0x00, 0x00,  //               ###               //
		     0x00, 0x3E, 0x00, 0x00,  //             #####               //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                //
		     0x00, 0x10, 0x00, 0x00,  //              #                  //

		     // @108   [-]   (26 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @216   [0]   (26 px wide)
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0xFF, 0xC0, 0x00,  //           ##########            //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xF3, 0xF0, 0x00,  //         ######  ######          //
		     0x03, 0xE1, 0xF0, 0x00,  //         #####    #####          //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x03, 0xE1, 0xF0, 0x00,  //         #####    #####          //
		     0x03, 0xF3, 0xF0, 0x00,  //         ######  ######          //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x00, 0xFF, 0xC0, 0x00,  //           ##########            //
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @324   [1]   (26 px wide)
		     0x00, 0x03, 0xE0, 0x00,  //                 #####           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x0F, 0xE0, 0x00,  //               #######           //
		     0x00, 0x1F, 0xE0, 0x00,  //              ########           //
		     0x00, 0x7F, 0xE0, 0x00,  //            ##########           //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x01, 0xF7, 0xE0, 0x00,  //          ##### ######           //
		     0x01, 0xE7, 0xE0, 0x00,  //          ####  ######           //
		     0x01, 0x07, 0xE0, 0x00,  //          #     ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @432   [2]   (26 px wide)
		     0x00, 0x7F, 0x80, 0x00,  //            ########             //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x07, 0xF3, 0xF8, 0x00,  //        #######  #######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x00, 0x01, 0xF8, 0x00,  //                  ######         //
		     0x00, 0x03, 0xF0, 0x00,  //                 ######          //
		     0x00, 0x07, 0xF0, 0x00,  //                #######          //
		     0x00, 0x0F, 0xE0, 0x00,  //               #######           //
		     0x00, 0x1F, 0xC0, 0x00,  //              #######            //
		     0x00, 0x3F, 0x80, 0x00,  //             #######             //
		     0x00, 0x7F, 0x00, 0x00,  //            #######              //
		     0x00, 0xFC, 0x00, 0x00,  //           ######                //
		     0x01, 0xF8, 0x00, 0x00,  //          ######                 //
		     0x03, 0xFF, 0xF8, 0x00,  //         ###############         //
		     0x03, 0xFF, 0xF8, 0x00,  //         ###############         //
		     0x03, 0xFF, 0xF8, 0x00,  //         ###############         //
		     0x07, 0xFF, 0xF8, 0x00,  //        ################         //
		     0x07, 0xFF, 0xF8, 0x00,  //        ################         //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @540   [3]   (26 px wide)
		     0x00, 0x7F, 0x80, 0x00,  //            ########             //
		     0x01, 0xFF, 0xC0, 0x00,  //          ###########            //
		     0x03, 0xFF, 0xE0, 0x00,  //         #############           //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x07, 0xF3, 0xF0, 0x00,  //        #######  ######          //
		     0x01, 0xE3, 0xF0, 0x00,  //          ####   ######          //
		     0x00, 0x03, 0xF0, 0x00,  //                 ######          //
		     0x00, 0x0F, 0xE0, 0x00,  //               #######           //
		     0x00, 0x0F, 0x80, 0x00,  //               #####             //
		     0x00, 0x0F, 0xE0, 0x00,  //               #######           //
		     0x00, 0x0F, 0xF0, 0x00,  //               ########          //
		     0x00, 0x03, 0xF8, 0x00,  //                 #######         //
		     0x00, 0x01, 0xF8, 0x00,  //                  ######         //
		     0x00, 0x01, 0xF8, 0x00,  //                  ######         //
		     0x01, 0xE1, 0xF8, 0x00,  //          ####    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x03, 0xF3, 0xF8, 0x00,  //         ######  #######         //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x00, 0xFF, 0xC0, 0x00,  //           ##########            //
		     0x00, 0x3F, 0x80, 0x00,  //             #######             //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @648   [4]   (26 px wide)
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x0F, 0xE0, 0x00,  //               #######           //
		     0x00, 0x1F, 0xE0, 0x00,  //              ########           //
		     0x00, 0x3F, 0xE0, 0x00,  //             #########           //
		     0x00, 0x3F, 0xE0, 0x00,  //             #########           //
		     0x00, 0x7F, 0xE0, 0x00,  //            ##########           //
		     0x00, 0xFF, 0xE0, 0x00,  //           ###########           //
		     0x01, 0xF7, 0xE0, 0x00,  //          ##### ######           //
		     0x03, 0xE7, 0xE0, 0x00,  //         #####  ######           //
		     0x03, 0xC7, 0xE0, 0x00,  //         ####   ######           //
		     0x07, 0x87, 0xE0, 0x00,  //        ####    ######           //
		     0x0F, 0x87, 0xE0, 0x00,  //       #####    ######           //
		     0x1F, 0x07, 0xE0, 0x00,  //      #####     ######           //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @756   [5]   (26 px wide)
		     0x00, 0xFF, 0xF0, 0x00,  //           ############          //
		     0x00, 0xFF, 0xF0, 0x00,  //           ############          //
		     0x00, 0xFF, 0xF0, 0x00,  //           ############          //
		     0x01, 0xFF, 0xF0, 0x00,  //          #############          //
		     0x01, 0xFF, 0xF0, 0x00,  //          #############          //
		     0x01, 0xF0, 0x00, 0x00,  //          #####                  //
		     0x01, 0xF0, 0x00, 0x00,  //          #####                  //
		     0x01, 0xF7, 0xC0, 0x00,  //          ##### #####            //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xF3, 0xF8, 0x00,  //         ######  #######         //
		     0x00, 0x01, 0xF8, 0x00,  //                  ######         //
		     0x00, 0x01, 0xF8, 0x00,  //                  ######         //
		     0x00, 0x01, 0xF8, 0x00,  //                  ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xF3, 0xF0, 0x00,  //        #######  ######          //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xFF, 0xE0, 0x00,  //         #############           //
		     0x00, 0xFF, 0xC0, 0x00,  //           ##########            //
		     0x00, 0x7F, 0x00, 0x00,  //            #######              //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @864   [6]   (26 px wide)
		     0x00, 0x3F, 0x80, 0x00,  //             #######             //
		     0x00, 0xFF, 0xE0, 0x00,  //           ###########           //
		     0x01, 0xFF, 0xF0, 0x00,  //          #############          //
		     0x01, 0xFF, 0xF0, 0x00,  //          #############          //
		     0x03, 0xF3, 0xF8, 0x00,  //         ######  #######         //
		     0x03, 0xF1, 0xF0, 0x00,  //         ######   #####          //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE7, 0x80, 0x00,  //        ######  ####             //
		     0x07, 0xEF, 0xE0, 0x00,  //        ###### #######           //
		     0x07, 0xFF, 0xF0, 0x00,  //        ###############          //
		     0x07, 0xFF, 0xF0, 0x00,  //        ###############          //
		     0x07, 0xF3, 0xF8, 0x00,  //        #######  #######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x03, 0xE1, 0xF8, 0x00,  //         #####    ######         //
		     0x03, 0xF3, 0xF8, 0x00,  //         ######  #######         //
		     0x01, 0xFF, 0xF0, 0x00,  //          #############          //
		     0x01, 0xFF, 0xF0, 0x00,  //          #############          //
		     0x00, 0xFF, 0xE0, 0x00,  //           ###########           //
		     0x00, 0x3F, 0x80, 0x00,  //             #######             //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @972   [7]   (26 px wide)
		     0x07, 0xFF, 0xF8, 0x00,  //        ################         //
		     0x07, 0xFF, 0xF8, 0x00,  //        ################         //
		     0x07, 0xFF, 0xF8, 0x00,  //        ################         //
		     0x07, 0xFF, 0xF8, 0x00,  //        ################         //
		     0x07, 0xFF, 0xF8, 0x00,  //        ################         //
		     0x00, 0x01, 0xF0, 0x00,  //                  #####          //
		     0x00, 0x03, 0xE0, 0x00,  //                 #####           //
		     0x00, 0x07, 0xC0, 0x00,  //                #####            //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######            //
		     0x00, 0x0F, 0x80, 0x00,  //               #####             //
		     0x00, 0x1F, 0x00, 0x00,  //              #####              //
		     0x00, 0x1F, 0x00, 0x00,  //              #####              //
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0x3E, 0x00, 0x00,  //             #####               //
		     0x00, 0x7E, 0x00, 0x00,  //            ######               //
		     0x00, 0x7E, 0x00, 0x00,  //            ######               //
		     0x00, 0x7E, 0x00, 0x00,  //            ######               //
		     0x00, 0x7C, 0x00, 0x00,  //            #####                //
		     0x00, 0xFC, 0x00, 0x00,  //           ######                //
		     0x00, 0xFC, 0x00, 0x00,  //           ######                //
		     0x00, 0xFC, 0x00, 0x00,  //           ######                //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @1080   [8]   (26 px wide)
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0xFF, 0xC0, 0x00,  //           ##########            //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xF3, 0xF0, 0x00,  //         ######  ######          //
		     0x03, 0xF3, 0xF0, 0x00,  //         ######  ######          //
		     0x03, 0xF3, 0xF0, 0x00,  //         ######  ######          //
		     0x03, 0xF3, 0xF0, 0x00,  //         ######  ######          //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x00, 0xFF, 0xC0, 0x00,  //           ##########            //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xF3, 0xF0, 0x00,  //         ######  ######          //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xF3, 0xF8, 0x00,  //        #######  #######         //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x00, 0x7F, 0x80, 0x00,  //            ########             //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @1188   [9]   (26 px wide)
		     0x00, 0x7F, 0x00, 0x00,  //            #######              //
		     0x01, 0xFF, 0xC0, 0x00,  //          ###########            //
		     0x03, 0xFF, 0xE0, 0x00,  //         #############           //
		     0x03, 0xFF, 0xE0, 0x00,  //         #############           //
		     0x07, 0xF3, 0xF0, 0x00,  //        #######  ######          //
		     0x07, 0xE1, 0xF0, 0x00,  //        ######    #####          //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xE1, 0xF8, 0x00,  //        ######    ######         //
		     0x07, 0xF3, 0xF8, 0x00,  //        #######  #######         //
		     0x03, 0xFF, 0xF8, 0x00,  //         ###############         //
		     0x03, 0xFF, 0xF8, 0x00,  //         ###############         //
		     0x01, 0xFD, 0xF8, 0x00,  //          ####### ######         //
		     0x00, 0x79, 0xF8, 0x00,  //            ####  ######         //
		     0x00, 0x01, 0xF8, 0x00,  //                  ######         //
		     0x03, 0xE3, 0xF0, 0x00,  //         #####   ######          //
		     0x07, 0xF3, 0xF0, 0x00,  //        #######  ######          //
		     0x03, 0xFF, 0xE0, 0x00,  //         #############           //
		     0x03, 0xFF, 0xE0, 0x00,  //         #############           //
		     0x01, 0xFF, 0xC0, 0x00,  //          ###########            //
		     0x00, 0x7F, 0x00, 0x00,  //            #######              //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @1296   [A]   (26 px wide)
		     0x00, 0x7F, 0x00, 0x00,  //            #######              //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x01, 0xFF, 0xC0, 0x00,  //          ###########            //
		     0x01, 0xF7, 0xC0, 0x00,  //          ##### #####            //
		     0x01, 0xF7, 0xC0, 0x00,  //          ##### #####            //
		     0x03, 0xF7, 0xE0, 0x00,  //         ###### ######           //
		     0x03, 0xE3, 0xE0, 0x00,  //         #####   #####           //
		     0x07, 0xE3, 0xF0, 0x00,  //        ######   ######          //
		     0x07, 0xE3, 0xF0, 0x00,  //        ######   ######          //
		     0x07, 0xC1, 0xF0, 0x00,  //        #####     #####          //
		     0x0F, 0xC1, 0xF8, 0x00,  //       ######     ######         //
		     0x0F, 0xFF, 0xF8, 0x00,  //       #################         //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x3F, 0xFF, 0xFE, 0x00,  //     #####################       //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x7E, 0x00, 0x3F, 0x00,  //    ######           ######      //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @1404   [C]   (26 px wide)
		     0x00, 0x3F, 0x80, 0x00,  //             #######             //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x03, 0xFF, 0xF8, 0x00,  //         ###############         //
		     0x07, 0xFF, 0xF8, 0x00,  //        ################         //
		     0x0F, 0xFF, 0xFC, 0x00,  //       ##################        //
		     0x0F, 0xE1, 0xFE, 0x00,  //       #######    ########       //
		     0x0F, 0xC0, 0xFE, 0x00,  //       ######      #######       //
		     0x1F, 0x80, 0x60, 0x00,  //      ######        ##           //
		     0x1F, 0x80, 0x00, 0x00,  //      ######                     //
		     0x1F, 0x80, 0x00, 0x00,  //      ######                     //
		     0x1F, 0x80, 0x00, 0x00,  //      ######                     //
		     0x1F, 0x80, 0x00, 0x00,  //      ######                     //
		     0x1F, 0x80, 0x60, 0x00,  //      ######        ##           //
		     0x1F, 0x80, 0x7C, 0x00,  //      ######        #####        //
		     0x0F, 0xC0, 0xFE, 0x00,  //       ######      #######       //
		     0x0F, 0xE1, 0xFC, 0x00,  //       #######    #######        //
		     0x0F, 0xFF, 0xFC, 0x00,  //       ##################        //
		     0x07, 0xFF, 0xF8, 0x00,  //        ################         //
		     0x03, 0xFF, 0xF8, 0x00,  //         ###############         //
		     0x01, 0xFF, 0xE0, 0x00,  //          ############           //
		     0x00, 0x7F, 0x80, 0x00,  //            ########             //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @1512   [D]   (26 px wide)
		     0x1F, 0xFF, 0x00, 0x00,  //      #############              //
		     0x1F, 0xFF, 0xC0, 0x00,  //      ###############            //
		     0x1F, 0xFF, 0xE0, 0x00,  //      ################           //
		     0x1F, 0xFF, 0xF0, 0x00,  //      #################          //
		     0x1F, 0xFF, 0xF8, 0x00,  //      ##################         //
		     0x1F, 0x83, 0xF8, 0x00,  //      ######     #######         //
		     0x1F, 0x81, 0xFC, 0x00,  //      ######      #######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x81, 0xFC, 0x00,  //      ######      #######        //
		     0x1F, 0x83, 0xF8, 0x00,  //      ######     #######         //
		     0x1F, 0xFF, 0xF8, 0x00,  //      ##################         //
		     0x1F, 0xFF, 0xF0, 0x00,  //      #################          //
		     0x1F, 0xFF, 0xE0, 0x00,  //      ################           //
		     0x1F, 0xFF, 0xC0, 0x00,  //      ###############            //
		     0x1F, 0xFF, 0x00, 0x00,  //      #############              //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @1620   [H]   (26 px wide)
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @1728   [L]   (26 px wide)
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xE0, 0x00, 0x00,  //        ######                   //
		     0x07, 0xFF, 0xF0, 0x00,  //        ###############          //
		     0x07, 0xFF, 0xF0, 0x00,  //        ###############          //
		     0x07, 0xFF, 0xF0, 0x00,  //        ###############          //
		     0x07, 0xFF, 0xF0, 0x00,  //        ###############          //
		     0x07, 0xFF, 0xF0, 0x00,  //        ###############          //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @1836   [N]   (26 px wide)
		     0x1F, 0x00, 0x7C, 0x00,  //      #####         #####        //
		     0x1F, 0x80, 0x7C, 0x00,  //      ######        #####        //
		     0x1F, 0xC0, 0x7C, 0x00,  //      #######       #####        //
		     0x1F, 0xC0, 0x7C, 0x00,  //      #######       #####        //
		     0x1F, 0xE0, 0x7C, 0x00,  //      ########      #####        //
		     0x1F, 0xF0, 0x7C, 0x00,  //      #########     #####        //
		     0x1F, 0xF0, 0x7C, 0x00,  //      #########     #####        //
		     0x1F, 0xF8, 0x7C, 0x00,  //      ##########    #####        //
		     0x1F, 0xFC, 0x7C, 0x00,  //      ###########   #####        //
		     0x1F, 0x7C, 0x7C, 0x00,  //      ##### #####   #####        //
		     0x1F, 0x3E, 0x7C, 0x00,  //      #####  #####  #####        //
		     0x1F, 0x1F, 0x7C, 0x00,  //      #####   ##### #####        //
		     0x1F, 0x1F, 0xFC, 0x00,  //      #####   ###########        //
		     0x1F, 0x0F, 0xFC, 0x00,  //      #####    ##########        //
		     0x1F, 0x07, 0xFC, 0x00,  //      #####     #########        //
		     0x1F, 0x07, 0xFC, 0x00,  //      #####     #########        //
		     0x1F, 0x03, 0xFC, 0x00,  //      #####      ########        //
		     0x1F, 0x01, 0xFC, 0x00,  //      #####       #######        //
		     0x1F, 0x01, 0xFC, 0x00,  //      #####       #######        //
		     0x1F, 0x00, 0xFC, 0x00,  //      #####        ######        //
		     0x1F, 0x00, 0x7C, 0x00,  //      #####         #####        //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @1944   [O]   (26 px wide)
		     0x00, 0x7F, 0x00, 0x00,  //            #######              //
		     0x03, 0xFF, 0xE0, 0x00,  //         #############           //
		     0x07, 0xFF, 0xF0, 0x00,  //        ###############          //
		     0x0F, 0xFF, 0xF8, 0x00,  //       #################         //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x1F, 0xC1, 0xFC, 0x00,  //      #######     #######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0xC1, 0xFC, 0x00,  //      #######     #######        //
		     0x1F, 0xFF, 0xFC, 0x00,  //      ###################        //
		     0x0F, 0xFF, 0xF8, 0x00,  //       #################         //
		     0x07, 0xFF, 0xF0, 0x00,  //        ###############          //
		     0x03, 0xFF, 0xE0, 0x00,  //         #############           //
		     0x00, 0x7F, 0x80, 0x00,  //            ########             //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @2052   [V]   (26 px wide)
		     0x7E, 0x00, 0x3F, 0x00,  //    ######           ######      //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x3F, 0x00, 0x7E, 0x00,  //     ######         ######       //
		     0x3F, 0x80, 0xFE, 0x00,  //     #######       #######       //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0x80, 0xFC, 0x00,  //      ######       ######        //
		     0x1F, 0xC1, 0xFC, 0x00,  //      #######     #######        //
		     0x0F, 0xC1, 0xF8, 0x00,  //       ######     ######         //
		     0x0F, 0xC1, 0xF8, 0x00,  //       ######     ######         //
		     0x07, 0xE3, 0xF0, 0x00,  //        ######   ######          //
		     0x07, 0xE3, 0xF0, 0x00,  //        ######   ######          //
		     0x07, 0xE3, 0xF0, 0x00,  //        ######   ######          //
		     0x03, 0xF7, 0xE0, 0x00,  //         ###### ######           //
		     0x03, 0xF7, 0xE0, 0x00,  //         ###### ######           //
		     0x03, 0xF7, 0xC0, 0x00,  //         ###### #####            //
		     0x01, 0xFF, 0xC0, 0x00,  //          ###########            //
		     0x01, 0xFF, 0xC0, 0x00,  //          ###########            //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x00, 0xFF, 0x80, 0x00,  //           #########             //
		     0x00, 0x7F, 0x00, 0x00,  //            #######              //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @2160   [m]   (26 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0xFC, 0xF8, 0x3E, 0x00,  //   ######  #####     #####       //
		     0xFD, 0xFE, 0x7F, 0x80,  //   ###### ########  ########     //
		     0xFF, 0xFE, 0xFF, 0x80,  //   ############### #########     //
		     0xFF, 0xFF, 0xFF, 0xC0,  //   ##########################    //
		     0xFF, 0xFF, 0xFF, 0xC0,  //   ##########################    //
		     0xFE, 0x7F, 0x9F, 0xC0,  //   #######  ########  #######    //
		     0xFC, 0x3F, 0x0F, 0xC0,  //   ######    ######    ######    //
		     0xFC, 0x3F, 0x0F, 0xC0,  //   ######    ######    ######    //
		     0xFC, 0x3F, 0x0F, 0xC0,  //   ######    ######    ######    //
		     0xFC, 0x3F, 0x0F, 0xC0,  //   ######    ######    ######    //
		     0xFC, 0x3F, 0x0F, 0xC0,  //   ######    ######    ######    //
		     0xFC, 0x3F, 0x0F, 0xC0,  //   ######    ######    ######    //
		     0xFC, 0x3F, 0x0F, 0xC0,  //   ######    ######    ######    //
		     0xFC, 0x3F, 0x0F, 0xC0,  //   ######    ######    ######    //
		     0xFC, 0x3F, 0x0F, 0xC0,  //   ######    ######    ######    //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //

		     // @2268   [z]   (26 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x01, 0xFF, 0xF0, 0x00,  //          #############          //
		     0x01, 0xFF, 0xF0, 0x00,  //          #############          //
		     0x01, 0xFF, 0xF0, 0x00,  //          #############          //
		     0x01, 0xFF, 0xF0, 0x00,  //          #############          //
		     0x00, 0x07, 0xE0, 0x00,  //                ######           //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######            //
		     0x00, 0x1F, 0x80, 0x00,  //              ######             //
		     0x00, 0x3F, 0x00, 0x00,  //             ######              //
		     0x00, 0x7E, 0x00, 0x00,  //            ######               //
		     0x00, 0xFC, 0x00, 0x00,  //           ######                //
		     0x01, 0xF8, 0x00, 0x00,  //          ######                 //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x03, 0xFF, 0xF0, 0x00,  //         ##############          //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
		     0x00, 0x00, 0x00, 0x00,  //                                 //
};


//szerokosc czcionki wynosi 16
const uint16_t font3desc[]=
{
		     0 ,		// ,  (44)
		    108 ,		// -  (45)
		    0 ,		// .
		    0 ,		// /
		    216 ,		// 0  (48)
		    324 ,		// 1  (49)
		    432 ,		// 2  (50)
		    540 ,		// 3  (51)
		    648 ,		// 4  (52)
		    756 ,		// 5  (53)
		    864 ,		// 6  (54)
		    972 ,		// 7  (55)
		    1080 ,		// 8  (56)
		    1188 ,		// 9  (57)
		    0 ,		// :
		    0 ,		// ;
		    0 ,		// <
		    0 ,		// =
		    0 ,		// >
		    0 ,		// ?
		    0 ,		// @
		    1296 ,		// A  (65)
		    0 ,		// B
		    1404 ,		// C  (67)
		    1512 ,		// D  (68)
		    0 ,		// E
		    0 ,		// F
		    0 ,		// G
		    1620 ,		// H  (72)
		    0 ,		// I
		    0 ,		// J
		    0 ,		// K
		    1728 ,		// L  (76)
		    0 ,		// M
		    1836 ,		// N  (78)
		    1944 ,		// O  (79)
		    0 ,		// P
		    0 ,		// Q
		    0 ,		// R
		    0 ,		// S
		    0 ,		// T
		    0 ,		// U
		    2052 ,		// V  (86)
		    0 ,		// W
		    0 ,		// X
		    0 ,		// Y
		    0 ,		// Z
		    0 ,		// [
		    0 ,		// //
		    0 ,		// ]
		    0 ,		// ^
		    0 ,		// _
		    0 ,		// `
		    0 ,		// a
		    0 ,		// b
		    0 ,		// c
		    0 ,		// d
		    0 ,		// e
		    0 ,		// f
		    0 ,		// g
		    0 ,		// h
		    0 ,		// i
		    0 ,		// j
		    0 ,		// k
		    0 ,		// l
		    2160 ,		// m  (109)
		    0 ,		// n
		    0 ,		// o
		    0 ,		// p
		    0 ,		// q
		    0 ,		// r
		    0 ,		// s
		    0 ,		// t
		    0 ,		// u
		    0 ,		// v
		    0 ,		// w
		    0 ,		// x
		    0 ,		// y
		   2268 ,		// z  (122)
};

const uint8_t fontinfo3[] =
{
		 27,  // Character height
		    ',',  //  Start character
		    0,  //  number of pixels of interspace between characters
		    26,  // number of pixels of space character
};



const uint8_t font6[]=
{

		  // @0   [!]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x04, 0x00,  //        #          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x00, 0x00,  //                   //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @26   ["]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x1B, 0x00,  //      ## ##        //
		     0x12, 0x00,  //      #  #         //
		     0x12, 0x00,  //      #  #         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @52   [#]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x04, 0x80,  //        #  #       //
		     0x04, 0x80,  //        #  #       //
		     0x1F, 0xC0,  //      #######      //
		     0x1F, 0xC0,  //      #######      //
		     0x12, 0x00,  //      #  #         //
		     0x7F, 0x00,  //    #######        //
		     0x7F, 0x00,  //    #######        //
		     0x2C, 0x00,  //     # ##          //
		     0x48, 0x00,  //    #  #           //
		     0x00, 0x00,  //                   //

		     // @78   [$]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x80,  //           #       //
		     0x00, 0x80,  //           #       //
		     0x07, 0x80,  //        ####       //
		     0x0D, 0x40,  //       ## # #      //
		     0x0D, 0x00,  //       ## #        //
		     0x0F, 0x00,  //       ####        //
		     0x07, 0x80,  //        ####       //
		     0x2B, 0x00,  //     # # ##        //
		     0x1E, 0x00,  //      ####         //
		     0x08, 0x00,  //       #           //
		     0x10, 0x00,  //      #            //

		     // @104   [%]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x78, 0x80,  //    ####   #       //
		     0xD9, 0x00,  //   ## ##  #        //
		     0xDA, 0x00,  //   ## ## #         //
		     0xF5, 0xE0,  //   #### # ####     //
		     0xEB, 0x60,  //   ### # ## ##     //
		     0x0B, 0x60,  //       # ## ##     //
		     0x13, 0xC0,  //      #  ####      //
		     0x23, 0x80,  //     #   ###       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @130   [&]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x1E, 0x00,  //      ####         //
		     0x36, 0x00,  //     ## ##         //
		     0x36, 0x00,  //     ## ##         //
		     0x28, 0xC0,  //     # #   ##      //
		     0x6D, 0x80,  //    ## ## ##       //
		     0x66, 0x00,  //    ##  ##         //
		     0x66, 0x00,  //    ##  ##         //
		     0x7B, 0x00,  //    #### ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @156   [']   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @182   [(]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //

		     // @208   [)]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //

		     // @234   [*]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x0B, 0x80,  //       # ###       //
		     0x0F, 0x00,  //       ####        //
		     0x16, 0x80,  //      # ## #       //
		     0x06, 0x00,  //        ##         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @260   [+]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x02, 0x00,  //         #         //
		     0x02, 0x00,  //         #         //
		     0x02, 0x00,  //         #         //
		     0x3F, 0x80,  //     #######       //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x08, 0x00,  //       #           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @286   [,]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x04, 0x00,  //        #          //
		     0x08, 0x00,  //       #           //
		     0x08, 0x00,  //       #           //

		     // @312   [-]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x00,  //       ####        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @338   [.]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @364   [/]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x40,  //            #      //
		     0x00, 0x80,  //           #       //
		     0x00, 0x80,  //           #       //
		     0x01, 0x00,  //          #        //
		     0x02, 0x00,  //         #         //
		     0x04, 0x00,  //        #          //
		     0x08, 0x00,  //       #           //
		     0x08, 0x00,  //       #           //
		     0x10, 0x00,  //      #            //
		     0x20, 0x00,  //     #             //
		     0x40, 0x00,  //    #              //

		     // @390   [0]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x00,  //        ###        //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x36, 0x00,  //     ## ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @416   [1]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x07, 0x00,  //        ###        //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @442   [2]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x00, 0xC0,  //           ##      //
		     0x01, 0x00,  //          #        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x3F, 0x00,  //     ######        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @468   [3]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x08, 0xC0,  //       #   ##      //
		     0x00, 0xC0,  //           ##      //
		     0x03, 0x00,  //         ##        //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x13, 0x00,  //      #  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @494   [4]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x07, 0x00,  //        ###        //
		     0x0B, 0x00,  //       # ##        //
		     0x16, 0x00,  //      # ##         //
		     0x3F, 0x00,  //     ######        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @520   [5]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x00,  //       ####        //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x7C, 0x00,  //    #####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @546   [6]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x1F, 0x00,  //      #####        //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x36, 0x00,  //     ## ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @572   [7]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @598   [8]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1E, 0x00,  //      ####         //
		     0x1B, 0x00,  //      ## ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x36, 0x00,  //     ## ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @624   [9]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x00,  //        ###        //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1F, 0x00,  //      #####        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @650   [:]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @676   [;]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x04, 0x00,  //        #          //
		     0x08, 0x00,  //       #           //
		     0x08, 0x00,  //       #           //

		     // @702   [<]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0xC0,  //           ##      //
		     0x03, 0x00,  //         ##        //
		     0x1C, 0x00,  //      ###          //
		     0x20, 0x00,  //     #             //
		     0x18, 0x00,  //      ##           //
		     0x06, 0x00,  //        ##         //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @728   [=]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x1F, 0xC0,  //      #######      //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x3F, 0x80,  //     #######       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @754   [>]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0C, 0x00,  //       ##          //
		     0x07, 0x00,  //        ###        //
		     0x01, 0xC0,  //          ###      //
		     0x00, 0x40,  //            #      //
		     0x01, 0x80,  //          ##       //
		     0x0E, 0x00,  //       ###         //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @780   [?]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x09, 0x80,  //       #  ##       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x00, 0x00,  //                   //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @806   [@]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x18, 0x40,  //      ##    #      //
		     0x27, 0xA0,  //     #  #### #     //
		     0x4D, 0xA0,  //    #  ## ## #     //
		     0x5B, 0x20,  //    # ## ##  #     //
		     0x5B, 0x40,  //    # ## ## #      //
		     0x5F, 0x80,  //    # ######       //
		     0x60, 0x00,  //    ##             //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //

		     // @832   [A]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x03, 0xC0,  //         ####      //
		     0x07, 0xC0,  //        #####      //
		     0x07, 0xC0,  //        #####      //
		     0x0D, 0xC0,  //       ## ###      //
		     0x1F, 0xC0,  //      #######      //
		     0x39, 0xC0,  //     ###  ###      //
		     0x31, 0xC0,  //     ##   ###      //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @858   [B]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x00,  //      ## ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @884   [C]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x1C, 0x00,  //      ###          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x30, 0x00,  //     ##            //
		     0x30, 0x00,  //     ##            //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @910   [D]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x18, 0xC0,  //      ##   ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x7C, 0x00,  //    #####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @936   [E]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x80,  //       #####       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @962   [F]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x80,  //       #####       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @988   [G]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0xC0,  //       ######      //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x30, 0x00,  //     ##            //
		     0x67, 0x00,  //    ##  ###        //
		     0x63, 0x00,  //    ##   ##        //
		     0x63, 0x00,  //    ##   ##        //
		     0x7E, 0x00,  //    ######         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1014   [H]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0C, 0x60,  //       ##   ##     //
		     0x18, 0xC0,  //      ##   ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x1F, 0xC0,  //      #######      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x63, 0x00,  //    ##   ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1040   [I]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1066   [J]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0xC0,  //         ####      //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1092   [K]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0xC0,  //        ## ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x0F, 0x00,  //       ####        //
		     0x0C, 0x00,  //       ##          //
		     0x1C, 0x00,  //      ###          //
		     0x1E, 0x00,  //      ####         //
		     0x1E, 0x00,  //      ####         //
		     0x33, 0x00,  //     ##  ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1118   [L]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x1F, 0x00,  //      #####        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1144   [M]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x18, 0x70,  //      ##    ###    //
		     0x38, 0xE0,  //     ###   ###     //
		     0x39, 0xE0,  //     ###  ####     //
		     0x3F, 0x60,  //     ###### ##     //
		     0x4E, 0xC0,  //    #  ### ##      //
		     0x40, 0xC0,  //    #      ##      //
		     0x40, 0xC0,  //    #      ##      //
		     0x81, 0x80,  //   #      ##       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1170   [N]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0C, 0x40,  //       ##   #      //
		     0x1C, 0x80,  //      ###  #       //
		     0x1E, 0x80,  //      #### #       //
		     0x1E, 0x80,  //      #### #       //
		     0x27, 0x00,  //     #  ###        //
		     0x23, 0x00,  //     #   ##        //
		     0x23, 0x00,  //     #   ##        //
		     0x40, 0x00,  //    #              //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1196   [O]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1222   [P]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x1F, 0x00,  //      #####        //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1248   [Q]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x0C, 0x00,  //       ##          //
		     0x0E, 0x00,  //       ###         //

		     // @1274   [R]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x1F, 0x00,  //      #####        //
		     0x1B, 0x00,  //      ## ##        //
		     0x1B, 0x00,  //      ## ##        //
		     0x31, 0x80,  //     ##   ##       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1300   [S]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x1E, 0x00,  //      ####         //
		     0x0F, 0x00,  //       ####        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x7C, 0x00,  //    #####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1326   [T]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x1F, 0x80,  //      ######       //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1352   [U]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x18, 0xC0,  //      ##   ##      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x63, 0x00,  //    ##   ##        //
		     0x63, 0x00,  //    ##   ##        //
		     0x66, 0x00,  //    ##  ##         //
		     0x7C, 0x00,  //    #####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1378   [V]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x31, 0x80,  //     ##   ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x36, 0x00,  //     ## ##         //
		     0x3C, 0x00,  //     ####          //
		     0x3C, 0x00,  //     ####          //
		     0x38, 0x00,  //     ###           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1404   [W]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0xC6, 0x60,  //   ##   ##  ##     //
		     0xCC, 0xC0,  //   ##  ##  ##      //
		     0xCD, 0xC0,  //   ##  ## ###      //
		     0xD5, 0x80,  //   ## # # ##       //
		     0xDF, 0x00,  //   ## #####        //
		     0xEF, 0x00,  //   ### ####        //
		     0xEE, 0x00,  //   ### ###         //
		     0xCC, 0x00,  //   ##  ##          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1430   [X]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x18, 0xC0,  //      ##   ##      //
		     0x1D, 0x80,  //      ### ##       //
		     0x0F, 0x00,  //       ####        //
		     0x0E, 0x00,  //       ###         //
		     0x0E, 0x00,  //       ###         //
		     0x1E, 0x00,  //      ####         //
		     0x36, 0x00,  //     ## ##         //
		     0x63, 0x00,  //    ##   ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1456   [Y]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x39, 0x80,  //     ###  ##       //
		     0x3B, 0x00,  //     ### ##        //
		     0x1E, 0x00,  //      ####         //
		     0x1C, 0x00,  //      ###          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1482   [Z]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0xC0,  //       ######      //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x80,  //         ###       //
		     0x0F, 0x00,  //       ####        //
		     0x1C, 0x00,  //      ###          //
		     0x38, 0x00,  //     ###           //
		     0x30, 0x00,  //     ##            //
		     0x7E, 0x00,  //    ######         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1508   [[]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0xC0,  //         ####      //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x3C, 0x00,  //     ####          //

		     // @1534   [\]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x02, 0x00,  //         #         //
		     0x02, 0x00,  //         #         //

		     // @1560   []]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0xC0,  //         ####      //
		     0x00, 0xC0,  //           ##      //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //

		     // @1586   [^]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x05, 0x00,  //        # #        //
		     0x08, 0x80,  //       #   #       //
		     0x10, 0x80,  //      #    #       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1612   [_]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x3F, 0x80,  //     #######       //

		     // @1638   [`]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x02, 0x00,  //         #         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1664   [a]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x01, 0x80,  //          ##       //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x80,  //      ## ###       //
		     0x1F, 0x00,  //      #####        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1690   [b]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x80,  //       #####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x00,  //      ## ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1716   [c]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0C, 0x80,  //       ##  #       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x19, 0x00,  //      ##  #        //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1742   [d]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0xC0,  //           ##      //
		     0x00, 0xC0,  //           ##      //
		     0x01, 0x80,  //          ##       //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1768   [e]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x1F, 0x80,  //      ######       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x1F, 0x00,  //      #####        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1794   [f]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x80,  //         ###       //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0E, 0x00,  //       ###         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1820   [g]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1F, 0x00,  //      #####        //
		     0x03, 0x00,  //         ##        //
		     0x3C, 0x00,  //     ####          //

		     // @1846   [h]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x80,  //       #####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1872   [i]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1898   [j]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x00, 0x00,  //                   //
		     0x07, 0x00,  //        ###        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x38, 0x00,  //     ###           //

		     // @1924   [k]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0D, 0x80,  //       ## ##       //
		     0x0F, 0x00,  //       ####        //
		     0x1E, 0x00,  //      ####         //
		     0x1E, 0x00,  //      ####         //
		     0x1E, 0x00,  //      ####         //
		     0x33, 0x00,  //     ##  ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1950   [l]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1976   [m]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x3E, 0xE0,  //     ##### ###     //
		     0x37, 0x60,  //     ## ### ##     //
		     0x66, 0x60,  //    ##  ##  ##     //
		     0x66, 0x60,  //    ##  ##  ##     //
		     0x66, 0x60,  //    ##  ##  ##     //
		     0xCC, 0xC0,  //   ##  ##  ##      //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2002   [n]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2028   [o]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x00,  //      ## ##        //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2054   [p]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x06, 0xC0,  //        ## ##      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x1F, 0x00,  //      #####        //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //

		     // @2080   [q]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //

		     // @2106   [r]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x80,  //        ## #       //
		     0x07, 0x80,  //        ####       //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2132   [s]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0C, 0x00,  //       ##          //
		     0x1E, 0x00,  //      ####         //
		     0x0F, 0x00,  //       ####        //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2158   [t]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x00,  //       ####        //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x1C, 0x00,  //      ###          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2184   [u]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2210   [v]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x00,  //      ## ##        //
		     0x1E, 0x00,  //      ####         //
		     0x1E, 0x00,  //      ####         //
		     0x1C, 0x00,  //      ###          //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2236   [w]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x36, 0xC0,  //     ## ## ##      //
		     0x3F, 0x80,  //     #######       //
		     0x2D, 0x80,  //     # ## ##       //
		     0x7D, 0x00,  //    ##### #        //
		     0x77, 0x00,  //    ### ###        //
		     0x66, 0x00,  //    ##  ##         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2262   [x]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x0F, 0x00,  //       ####        //
		     0x0F, 0x00,  //       ####        //
		     0x1B, 0x00,  //      ## ##        //
		     0x31, 0x80,  //     ##   ##       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2288   [y]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x0D, 0x00,  //       ## #        //
		     0x0F, 0x00,  //       ####        //
		     0x0E, 0x00,  //       ###         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //

		     // @2314   [z]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2340   [{]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0xC0,  //          ###      //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x38, 0x00,  //     ###           //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x1C, 0x00,  //      ###          //

		     // @2366   [|]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //

		     // @2392   [}]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x80,  //         ###       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0xC0,  //          ###      //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //

		     // @2418   [~]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x38, 0xC0,  //     ###   ##      //
		     0x4C, 0x80,  //    #  ##  #       //
		     0x47, 0x00,  //    #   ###        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2444   [Ĺš]   (12 px wide)
		     0x01, 0x80,  //          ##       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x1E, 0x00,  //      ####         //
		     0x0F, 0x00,  //       ####        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x7C, 0x00,  //    #####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2470   [Ĺą]   (12 px wide)
		     0x01, 0x80,  //          ##       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x0F, 0xC0,  //       ######      //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x80,  //         ###       //
		     0x0F, 0x00,  //       ####        //
		     0x1C, 0x00,  //      ###          //
		     0x38, 0x00,  //     ###           //
		     0x30, 0x00,  //     ##            //
		     0x7E, 0x00,  //    ######         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2496   [Ĺ›]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x80,  //           #       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0C, 0x00,  //       ##          //
		     0x1E, 0x00,  //      ####         //
		     0x0F, 0x00,  //       ####        //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2522   [Ĺş]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x00,  //          #        //
		     0x02, 0x00,  //         #         //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2548   [Ĺ�]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x80,  //        ## #       //
		     0x07, 0x00,  //        ###        //
		     0x0C, 0x00,  //       ##          //
		     0x1C, 0x00,  //      ###          //
		     0x0C, 0x00,  //       ##          //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2574   [Ä„]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x03, 0xC0,  //         ####      //
		     0x07, 0xC0,  //        #####      //
		     0x07, 0xC0,  //        #####      //
		     0x0D, 0xC0,  //       ## ###      //
		     0x1F, 0xC0,  //      #######      //
		     0x39, 0xC0,  //     ###  ###      //
		     0x31, 0xC0,  //     ##   ###      //
		     0x01, 0x00,  //          #        //
		     0x01, 0x00,  //          #        //

		     // @2600   [Ĺ»]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x00, 0x00,  //                   //
		     0x0F, 0xC0,  //       ######      //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x80,  //         ###       //
		     0x0F, 0x00,  //       ####        //
		     0x1C, 0x00,  //      ###          //
		     0x38, 0x00,  //     ###           //
		     0x30, 0x00,  //     ##            //
		     0x7E, 0x00,  //    ######         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2626   [Ĺ‚]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x07, 0x00,  //        ###        //
		     0x0E, 0x00,  //       ###         //
		     0x1C, 0x00,  //      ###          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2652   [Ä…]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x01, 0x80,  //          ##       //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x80,  //      ## ###       //
		     0x1F, 0x00,  //      #####        //
		     0x02, 0x00,  //         #         //
		     0x02, 0x00,  //         #         //

		     // @2678   [ĹĽ]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2704   [Ä†]   (12 px wide)
		     0x01, 0x80,  //          ##       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x1C, 0x00,  //      ###          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x30, 0x00,  //     ##            //
		     0x30, 0x00,  //     ##            //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2730   [Ä�]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x80,  //       #####       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x3E, 0x00,  //     #####         //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //

		     // @2756   [Ĺ�]   (12 px wide)
		     0x01, 0x80,  //          ##       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x0C, 0x40,  //       ##   #      //
		     0x1C, 0x80,  //      ###  #       //
		     0x1E, 0x80,  //      #### #       //
		     0x1E, 0x80,  //      #### #       //
		     0x27, 0x00,  //     #  ###        //
		     0x23, 0x00,  //     #   ##        //
		     0x23, 0x00,  //     #   ##        //
		     0x40, 0x00,  //    #              //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2782   [Ă“]   (12 px wide)
		     0x01, 0x80,  //          ##       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2808   [Ä‡]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x80,  //           #       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0C, 0x80,  //       ##  #       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x19, 0x00,  //      ##  #        //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2834   [Ä™]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x1F, 0x80,  //      ######       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x0F, 0x00,  //       ####        //
		     0x02, 0x00,  //         #         //
		     0x02, 0x00,  //         #         //

		     // @2860   [Ĺ„]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x80,  //           #       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2886   [Ăł]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x80,  //           #       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x00,  //      ## ##        //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

};


const uint16_t font6desc[]=
{

		0 ,		// !  (33)
		    26 ,		// "  (34)
		    52 ,		// #  (35)
		    78 ,		// $  (36)
		    104 ,		// %  (37)
		    130 ,		// &  (38)
		    156 ,		// '  (39)
		    182 ,		// (  (40)
		    208 ,		// )  (41)
		    234 ,		// *  (42)
		   260 ,		// +  (43)
		    286 ,		// ,  (44)
		    312 ,		// -  (45)
		    338 ,		// .  (46)
		    364 ,		// /  (47)
		    390 ,		// 0  (48)
		    416 ,		// 1  (49)
		    442 ,		// 2  (50)
		    468 ,		// 3  (51)
		   494 ,		// 4  (52)
		    520 ,		// 5  (53)
		    546 ,		// 6  (54)
		   572 ,		// 7  (55)
		   598 ,		// 8  (56)
		    624 ,		// 9  (57)
		    650 ,		// :  (58)
		    676 ,		// ;  (59)
		    702 ,		// <  (60)
		    728 ,		// =  (61)
		    754 ,		// >  (62)
		    780 ,		// ?  (63)
		    806 ,		// @  (64)
		    832 ,		// A  (65)
		    858 ,		// B  (66)
		    884 ,		// C  (67)
		    910 ,		// D  (68)
		    936 ,		// E  (69)
		    962 ,		// F  (70)
		    988 ,		// G  (71)
		    1014 ,		// H  (72)
		    1040 ,		// I  (73)
		    1066 ,		// J  (74)
		    1092 ,		// K  (75)
		    1118 ,		// L  (76)
		    1144 ,		// M  (77)
		    1170 ,		// N  (78)
		    1196 ,		// O  (79)
		    1222 ,		// P  (80)
		    1248 ,		// Q  (81)
		    1274 ,		// R  (82)
		    1300 ,		// S  (83)
		    1326 ,		// T  (84)
		    1352 ,		// U  (85)
		    1378 ,		// V  (86)
		    1404 ,		// W  (87)
		    1430 ,		// X  (88)
		    1456 ,		// Y  (89)
		    1482 ,		// Z  (90)
		    1508 ,		// [  (91)
		    1534 ,		// //  (92)
		    1560 ,		// ]  (93)
		    1586 ,		// ^  (94)
		    1612 ,		// _  (95)
		    1638 ,		// `  (96)
		    1664 ,		// a  (97)
		    1690 ,		// b  (98)
		    1716 ,		// c  (99)
		    1742 ,		// d  (100)
		    1768 ,		// e  (101)
		    1794 ,		// f  (102)
		    1820 ,		// g  (103)
		    1846 ,		// h  (104)
		    1872 ,		// i  (105)
		    1898 ,		// j  (106)
		    1924 ,		// k  (107)
		    1950 ,		// l  (108)
		    1976 ,		// m  (109)
		    2002 ,		// n  (110)
		    2028 ,		// o  (111)
		    2054 ,		// p  (112)
		    2080 ,		// q  (113)
		    2106 ,		// r  (114)
		    2132 ,		// s  (115)
		    2158 ,		// t  (116)
		    2184 ,		// u  (117)
		    2210 ,		// v  (118)
		    2236 ,		// w  (119)
		    2262 ,		// x  (120)
		    2288 ,		// y  (121)
		    2314 ,		// z  (122)
		    2340 ,		// {  (123)
		    2366 ,		// |  (124)
		    2392 ,		// }  (125)
		    2418 ,		// ~  (126)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2444 ,		// Ĺš  (140)
		    0 ,		//
		    0 ,		//
		    2470 ,		// Ĺą  (143)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2496 ,		// Ĺ›  (156)
		    0 ,		//
		    0 ,		//
		    2522 ,		// Ĺş  (159)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2548 ,		// Ĺ�  (163)
		    0 ,		//
		    2574 ,		// Ä„  (165)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2600 ,	// Ĺ»  (175)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2626 ,		// Ĺ‚  (179)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2652 ,		// Ä…  (185)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2678 ,		// ĹĽ  (191)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2704 ,		// Ä†  (198)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2730 ,		// Ä�  (202)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2756 ,		// Ĺ�  (209)
		    0 ,		//
		    2782 ,		// Ă“  (211)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2808 ,		// Ä‡  (230)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2834 ,		// Ä™  (234)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2860 ,		// Ĺ„  (241)
		    0 ,		//
		    2886 		// Ăł  (243)
};

const uint8_t fontinfo6[]=
{
		 13,  // Character height
		    '!',  //  Start character
		    0,  //  number of pixels of interspace between characters
		    12,  // number of pixels of space character
};


//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
// Czcionka 4 oraz 5 odpowiedzialne za nazwy kanalu wyswietlanie wartosci oraz jednostki

const uint8_t font4[]=
{
	     // @0   [!]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x10, 0x00,  //              #               //
	     0x00, 0x10, 0x00,  //              #               //
	     0x00, 0x10, 0x00,  //              #               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @87   ["]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @174   [#]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x73, 0x80,  //            ###  ###          //
	     0x00, 0x73, 0x80,  //            ###  ###          //
	     0x00, 0xE7, 0x00,  //           ###  ###           //
	     0x00, 0xE7, 0x00,  //           ###  ###           //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x03, 0x9C, 0x00,  //         ###  ###             //
	     0x03, 0x9C, 0x00,  //         ###  ###             //
	     0x07, 0x38, 0x00,  //        ###  ###              //
	     0x07, 0x38, 0x00,  //        ###  ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @261   [$]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xDB, 0x80,  //          ### ## ###          //
	     0x01, 0xDB, 0x80,  //          ### ## ###          //
	     0x01, 0xD8, 0x00,  //          ### ##              //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x1B, 0x80,  //              ## ###          //
	     0x03, 0x9B, 0x80,  //         ###  ## ###          //
	     0x03, 0xDB, 0x80,  //         #### ## ###          //
	     0x01, 0xDB, 0x80,  //          ### ## ###          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @348   [%]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0x03, 0x00,  //       ####      ##           //
	     0x0F, 0x07, 0x00,  //       ####     ###           //
	     0x19, 0x86, 0x00,  //      ##  ##    ##            //
	     0x19, 0x86, 0x00,  //      ##  ##    ##            //
	     0x19, 0x8C, 0x00,  //      ##  ##   ##             //
	     0x19, 0x8C, 0x00,  //      ##  ##   ##             //
	     0x19, 0x98, 0x00,  //      ##  ##  ##              //
	     0x0F, 0x18, 0x00,  //       ####   ##              //
	     0x0F, 0x30, 0x00,  //       ####  ##               //
	     0x00, 0x33, 0xC0,  //             ##  ####         //
	     0x00, 0x73, 0xC0,  //            ###  ####         //
	     0x00, 0x66, 0x60,  //            ##  ##  ##        //
	     0x00, 0x66, 0x60,  //            ##  ##  ##        //
	     0x00, 0xC6, 0x60,  //           ##   ##  ##        //
	     0x00, 0xC6, 0x60,  //           ##   ##  ##        //
	     0x01, 0x86, 0x60,  //          ##    ##  ##        //
	     0x01, 0x83, 0xC0,  //          ##     ####         //
	     0x03, 0x03, 0xC0,  //         ##      ####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @435   [&]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0x0E, 0x00,  //        ###    ###            //
	     0x07, 0x0E, 0x00,  //        ###    ###            //
	     0x07, 0x9E, 0x00,  //        ####  ####            //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x03, 0xF0, 0x00,  //         ######               //
	     0x07, 0xF0, 0x00,  //        #######               //
	     0x0F, 0x79, 0xC0,  //       #### ####  ###         //
	     0x1E, 0x3F, 0xC0,  //      ####   ########         //
	     0x1C, 0x1F, 0x80,  //      ###     ######          //
	     0x1C, 0x0F, 0x00,  //      ###      ####           //
	     0x1E, 0x1F, 0xC0,  //      ####    #######         //
	     0x0F, 0xFF, 0xE0,  //       ###############        //
	     0x0F, 0xFD, 0xC0,  //       ########## ###         //
	     0x03, 0xF0, 0x80,  //         ######    #          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @522   [']   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @609   [(]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x00, 0x00,  //                              //

	     // @696   [)]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x00, 0x00,  //                              //

	     // @783   [*]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x01, 0xB6, 0x00,  //          ## ## ##            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xCC, 0x00,  //           ##  ##             //
	     0x00, 0x48, 0x00,  //            #  #              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @870   [+]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @957   [,]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x20, 0x00,  //             #                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1044   [-]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1131   [.]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1218   [/]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1305   [0]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1392   [1]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0x8E, 0x00,  //           #   ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1479   [2]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1566   [3]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC7, 0x00,  //         ####   ###           //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3F, 0x00,  //             ######           //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1653   [4]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0x8E, 0x00,  //         ###   ###            //
	     0x07, 0x0E, 0x00,  //        ###    ###            //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1740   [5]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0x87, 0x80,  //         ###    ####          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x00,  //         ####   ###           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1827   [6]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xC7, 0x80,  //          ###   ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0xBC, 0x00,  //         ### ####             //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x01, 0xC7, 0x80,  //          ###   ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1914   [7]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2001   [8]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2088   [9]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC7, 0x00,  //         ####   ###           //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x7B, 0x80,  //            #### ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x00,  //         ####   ###           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2175   [:]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2262   [;]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x20, 0x00,  //             #                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2349   [<]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x80,  //                   #          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x00, 0x80,  //                   #          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2436   [=]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2523   [>]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x04, 0x00, 0x00,  //        #                     //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x04, 0x00, 0x00,  //        #                     //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2610   [?]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x00, 0x01, 0xC0,  //                  ###         //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2697   [@]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x1F, 0x03, 0xE0,  //      #####      #####        //
	     0x3D, 0xEF, 0xF0,  //     #### #### ########       //
	     0x3B, 0xFE, 0x70,  //     ### #########  ###       //
	     0x7F, 0xFE, 0x38,  //    ##############   ###      //
	     0x77, 0x1E, 0x38,  //    ### ###   ####   ###      //
	     0xF7, 0x1E, 0x38,  //   #### ###   ####   ###      //
	     0xEE, 0x1E, 0x38,  //   ### ###    ####   ###      //
	     0xEE, 0x1C, 0x38,  //   ### ###    ###    ###      //
	     0xEE, 0x1C, 0x78,  //   ### ###    ###   ####      //
	     0xEE, 0x3C, 0x70,  //   ### ###   ####   ###       //
	     0xEE, 0x3C, 0xE0,  //   ### ###   ####  ###        //
	     0xEF, 0xFF, 0xE0,  //   ### ###############        //
	     0xF7, 0xFF, 0x80,  //   #### ############          //
	     0x73, 0x9F, 0x00,  //    ###  ###  #####           //
	     0x78, 0x00, 0x3C,  //    ####             ####     //
	     0x3C, 0x00, 0x78,  //     ####           ####      //
	     0x1F, 0x01, 0xF0,  //      #####       #####       //
	     0x0F, 0xFF, 0xE0,  //       ###############        //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0xFF, 0x00,  //           ########           //

	     // @2784   [A]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x0E, 0x00, 0xE0,  //       ###         ###        //
	     0x0E, 0x00, 0xE0,  //       ###         ###        //
	     0x0E, 0x00, 0xE0,  //       ###         ###        //
	     0x1C, 0x00, 0x70,  //      ###           ###       //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2871   [B]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0xFE, 0x00,  //       ###########            //
	     0x0F, 0xFF, 0x00,  //       ############           //
	     0x0F, 0xFF, 0x00,  //       ############           //
	     0x0E, 0x07, 0x80,  //       ###      ####          //
	     0x0E, 0x03, 0x80,  //       ###       ###          //
	     0x0E, 0x03, 0x80,  //       ###       ###          //
	     0x0E, 0x07, 0x80,  //       ###      ####          //
	     0x0F, 0xFF, 0x00,  //       ############           //
	     0x0F, 0xFF, 0x00,  //       ############           //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x0E, 0x03, 0xC0,  //       ###       ####         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0E, 0x03, 0xC0,  //       ###       ####         //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x0F, 0xFE, 0x00,  //       ###########            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2958   [C]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x07, 0x83, 0xE0,  //        ####     #####        //
	     0x07, 0x00, 0xC0,  //        ###        ##         //
	     0x0F, 0x00, 0x00,  //       ####                   //
	     0x0E, 0x00, 0x00,  //       ###                    //
	     0x0E, 0x00, 0x00,  //       ###                    //
	     0x0E, 0x00, 0x00,  //       ###                    //
	     0x0E, 0x00, 0x00,  //       ###                    //
	     0x0E, 0x00, 0x00,  //       ###                    //
	     0x0F, 0x00, 0x00,  //       ####                   //
	     0x07, 0x00, 0xC0,  //        ###        ##         //
	     0x07, 0x83, 0xE0,  //        ####     #####        //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3045   [D]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0xFC, 0x00,  //       ##########             //
	     0x0F, 0xFE, 0x00,  //       ###########            //
	     0x0F, 0xFF, 0x00,  //       ############           //
	     0x0E, 0x07, 0x80,  //       ###      ####          //
	     0x0E, 0x03, 0x80,  //       ###       ###          //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0E, 0x03, 0x80,  //       ###       ###          //
	     0x0E, 0x07, 0x80,  //       ###      ####          //
	     0x0F, 0xFF, 0x00,  //       ############           //
	     0x0F, 0xFE, 0x00,  //       ###########            //
	     0x0F, 0xFC, 0x00,  //       ##########             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3132   [E]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3219   [F]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3306   [G]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x0F, 0x83, 0xE0,  //       #####     #####        //
	     0x0E, 0x00, 0xC0,  //       ###         ##         //
	     0x1E, 0x00, 0x00,  //      ####                    //
	     0x1C, 0x00, 0x00,  //      ###                     //
	     0x1C, 0x00, 0x00,  //      ###                     //
	     0x1C, 0x0F, 0xE0,  //      ###      #######        //
	     0x1C, 0x0F, 0xE0,  //      ###      #######        //
	     0x1C, 0x0F, 0xE0,  //      ###      #######        //
	     0x1E, 0x00, 0xE0,  //      ####         ###        //
	     0x0E, 0x00, 0xE0,  //       ###         ###        //
	     0x0F, 0x83, 0xE0,  //       #####     #####        //
	     0x07, 0xFF, 0xE0,  //        ##############        //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3393   [H]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3480   [I]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3567   [J]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3654   [K]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0E, 0x03, 0xC0,  //       ###       ####         //
	     0x0E, 0x07, 0x80,  //       ###      ####          //
	     0x0E, 0x0F, 0x00,  //       ###     ####           //
	     0x0E, 0x1E, 0x00,  //       ###    ####            //
	     0x0E, 0x3C, 0x00,  //       ###   ####             //
	     0x0E, 0x78, 0x00,  //       ###  ####              //
	     0x0E, 0xF0, 0x00,  //       ### ####               //
	     0x0F, 0xF8, 0x00,  //       #########              //
	     0x0F, 0xFC, 0x00,  //       ##########             //
	     0x0F, 0x9C, 0x00,  //       #####  ###             //
	     0x0F, 0x1E, 0x00,  //       ####   ####            //
	     0x0E, 0x0E, 0x00,  //       ###     ###            //
	     0x0E, 0x07, 0x00,  //       ###      ###           //
	     0x0E, 0x07, 0x00,  //       ###      ###           //
	     0x0E, 0x03, 0x80,  //       ###       ###          //
	     0x0E, 0x03, 0xC0,  //       ###       ####         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3741   [L]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3828   [M]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x1F, 0x01, 0xF0,  //      #####       #####       //
	     0x1F, 0x01, 0xF0,  //      #####       #####       //
	     0x1F, 0x83, 0xF0,  //      ######     ######       //
	     0x1F, 0x83, 0xF0,  //      ######     ######       //
	     0x1D, 0x83, 0x70,  //      ### ##     ## ###       //
	     0x1D, 0xC7, 0x70,  //      ### ###   ### ###       //
	     0x1D, 0xC7, 0x70,  //      ### ###   ### ###       //
	     0x1C, 0xC6, 0x70,  //      ###  ##   ##  ###       //
	     0x1C, 0xEE, 0x70,  //      ###  ### ###  ###       //
	     0x1C, 0xEE, 0x70,  //      ###  ### ###  ###       //
	     0x1C, 0xEE, 0x70,  //      ###  ### ###  ###       //
	     0x1C, 0x6C, 0x70,  //      ###   ## ##   ###       //
	     0x1C, 0x7C, 0x70,  //      ###   #####   ###       //
	     0x1C, 0x7C, 0x70,  //      ###   #####   ###       //
	     0x1C, 0x7C, 0x70,  //      ###   #####   ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3915   [N]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x81, 0xC0,  //        ####      ###         //
	     0x07, 0xC1, 0xC0,  //        #####     ###         //
	     0x07, 0xC1, 0xC0,  //        #####     ###         //
	     0x07, 0xE1, 0xC0,  //        ######    ###         //
	     0x07, 0xE1, 0xC0,  //        ######    ###         //
	     0x07, 0x71, 0xC0,  //        ### ###   ###         //
	     0x07, 0x71, 0xC0,  //        ### ###   ###         //
	     0x07, 0x39, 0xC0,  //        ###  ###  ###         //
	     0x07, 0x3D, 0xC0,  //        ###  #### ###         //
	     0x07, 0x1D, 0xC0,  //        ###   ### ###         //
	     0x07, 0x0F, 0xC0,  //        ###    ######         //
	     0x07, 0x0F, 0xC0,  //        ###    ######         //
	     0x07, 0x07, 0xC0,  //        ###     #####         //
	     0x07, 0x07, 0xC0,  //        ###     #####         //
	     0x07, 0x03, 0xC0,  //        ###      ####         //
	     0x07, 0x03, 0xC0,  //        ###      ####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4002   [O]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x1E, 0x01, 0xE0,  //      ####        ####        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1E, 0x01, 0xE0,  //      ####        ####        //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4089   [P]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0x03, 0xC0,  //        ###      ####         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x03, 0xC0,  //        ###      ####         //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4176   [Q]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x1E, 0x01, 0xE0,  //      ####        ####        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1E, 0x11, 0xC0,  //      ####    #   ###         //
	     0x0E, 0x3F, 0xC0,  //       ###   ########         //
	     0x0F, 0x8F, 0x80,  //       #####   #####          //
	     0x07, 0xFF, 0xE0,  //        ##############        //
	     0x03, 0xFF, 0xF0,  //         ##############       //
	     0x00, 0xFD, 0xE0,  //           ###### ####        //
	     0x00, 0x00, 0x60,  //                    ##        //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4263   [R]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0xFE, 0x00,  //       ###########            //
	     0x0F, 0xFF, 0x00,  //       ############           //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x0E, 0x07, 0x80,  //       ###      ####          //
	     0x0E, 0x03, 0x80,  //       ###       ###          //
	     0x0E, 0x03, 0x80,  //       ###       ###          //
	     0x0E, 0x07, 0x80,  //       ###      ####          //
	     0x0F, 0xFF, 0x00,  //       ############           //
	     0x0F, 0xFE, 0x00,  //       ###########            //
	     0x0F, 0xF8, 0x00,  //       #########              //
	     0x0E, 0x3C, 0x00,  //       ###   ####             //
	     0x0E, 0x1E, 0x00,  //       ###    ####            //
	     0x0E, 0x0E, 0x00,  //       ###     ###            //
	     0x0E, 0x07, 0x00,  //       ###      ###           //
	     0x0E, 0x07, 0x80,  //       ###      ####          //
	     0x0E, 0x03, 0x80,  //       ###       ###          //
	     0x0E, 0x03, 0xC0,  //       ###       ####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4350   [S]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0xF0, 0x00,  //        #######               //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0F, 0x01, 0xC0,  //       ####       ###         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4437   [T]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4524   [U]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4611   [V]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x1C, 0x00, 0x70,  //      ###           ###       //
	     0x0E, 0x00, 0xE0,  //       ###         ###        //
	     0x0E, 0x00, 0xE0,  //       ###         ###        //
	     0x0F, 0x01, 0xE0,  //       ####       ####        //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4698   [W]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0xE0, 0x38, 0x0E,  //   ###       ###       ###    //
	     0xF0, 0x38, 0x1E,  //   ####      ###      ####    //
	     0x70, 0x7C, 0x1C,  //    ###     #####     ###     //
	     0x70, 0x7C, 0x1C,  //    ###     #####     ###     //
	     0x70, 0x6C, 0x1C,  //    ###     ## ##     ###     //
	     0x38, 0xEE, 0x38,  //     ###   ### ###   ###      //
	     0x38, 0xEE, 0x38,  //     ###   ### ###   ###      //
	     0x38, 0xEE, 0x38,  //     ###   ### ###   ###      //
	     0x3D, 0xC6, 0x78,  //     #### ###   ##  ####      //
	     0x1D, 0xC7, 0x70,  //      ### ###   ### ###       //
	     0x1D, 0xC7, 0x70,  //      ### ###   ### ###       //
	     0x1D, 0xC7, 0x70,  //      ### ###   ### ###       //
	     0x0F, 0x83, 0xE0,  //       #####     #####        //
	     0x0F, 0x83, 0xE0,  //       #####     #####        //
	     0x0F, 0x83, 0xE0,  //       #####     #####        //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4785   [X]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4872   [Y]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0E, 0x00, 0xE0,  //       ###         ###        //
	     0x0F, 0x01, 0xE0,  //       ####       ####        //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4959   [Z]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x0F, 0x00, 0x00,  //       ####                   //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5046   [[]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //

	     // @5133   [\]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5220   []]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //

	     // @5307   [^]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5394   [_]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x00, 0x00, 0x00,  //                              //

	     // @5481   [a]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0x8F, 0x00,  //         ###   ####           //
	     0x07, 0x07, 0x00,  //        ###     ###           //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x3F, 0x00,  //             ######           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xE7, 0x00,  //         #####  ###           //
	     0x07, 0x07, 0x00,  //        ###     ###           //
	     0x07, 0x07, 0x00,  //        ###     ###           //
	     0x07, 0x8F, 0x00,  //        ####   ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xF3, 0x80,  //          #####  ###          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5568   [b]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x3C, 0x00,  //        ###  ####             //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0x87, 0x00,  //        ####    ###           //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0x3C, 0x00,  //        ###  ####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5655   [c]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0x83, 0x00,  //         ###     ##           //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x83, 0x00,  //         ###     ##           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5742   [d]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0xF3, 0x80,  //           ####  ###          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0x87, 0x80,  //         ###    ####          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF3, 0x80,  //           ####  ###          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5829   [e]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC7, 0x00,  //         ####   ###           //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x01, 0xC3, 0x80,  //          ###    ###          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5916   [f]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6003   [g]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xF3, 0x80,  //           ####  ###          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0x87, 0x80,  //         ###    ####          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x03, 0x87, 0x80,  //         ###    ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF3, 0x80,  //           ####  ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x07, 0x07, 0x80,  //        ###     ####          //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0x00, 0x00,  //                              //

	     // @6090   [h]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x9E, 0x00,  //         ###  ####            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6177   [i]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6264   [j]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x00, 0x00,  //                              //

	     // @6351   [k]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x03, 0x8E, 0x00,  //         ###   ###            //
	     0x03, 0x9C, 0x00,  //         ###  ###             //
	     0x03, 0xB8, 0x00,  //         ### ###              //
	     0x03, 0xF0, 0x00,  //         ######               //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x03, 0xDC, 0x00,  //         #### ###             //
	     0x03, 0x9C, 0x00,  //         ###  ###             //
	     0x03, 0x8E, 0x00,  //         ###   ###            //
	     0x03, 0x8E, 0x00,  //         ###   ###            //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6438   [l]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6525   [m]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x1D, 0xE3, 0xC0,  //      ### ####   ####         //
	     0x1F, 0xF7, 0xE0,  //      ######### ######        //
	     0x1F, 0xFF, 0xF0,  //      #################       //
	     0x1E, 0x3C, 0x70,  //      ####   ####   ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x1C, 0x38, 0x70,  //      ###    ###    ###       //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6612   [n]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0x9E, 0x00,  //         ###  ####            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6699   [o]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6786   [p]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x7C, 0x00,  //        ### #####             //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0x87, 0x00,  //        ####    ###           //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0x3C, 0x00,  //        ###  ####             //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x00, 0x00, 0x00,  //                              //

	     // @6873   [q]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xF3, 0x80,  //           ####  ###          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0x87, 0x80,  //         ###    ####          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x03, 0x87, 0x80,  //         ###    ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF3, 0x80,  //           ####  ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x00, 0x00,  //                              //

	     // @6960   [r]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7047   [s]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x01, 0xC3, 0x80,  //          ###    ###          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7134   [t]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x08, 0x00,  //               #              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7221   [u]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF3, 0x80,  //           ####  ###          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7308   [v]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0x6C, 0x00,  //            ## ##             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7395   [w]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x38, 0x38, 0x38,  //     ###     ###     ###      //
	     0x3C, 0x38, 0x38,  //     ####    ###     ###      //
	     0x1C, 0x7C, 0x70,  //      ###   #####   ###       //
	     0x1C, 0x7C, 0x70,  //      ###   #####   ###       //
	     0x1C, 0x7C, 0x70,  //      ###   #####   ###       //
	     0x0E, 0xEE, 0xE0,  //       ### ### ### ###        //
	     0x0E, 0xEE, 0xE0,  //       ### ### ### ###        //
	     0x0E, 0xEE, 0xE0,  //       ### ### ### ###        //
	     0x06, 0xC6, 0xC0,  //        ## ##   ## ##         //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7482   [x]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7569   [y]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x00,  //         ####   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x01, 0xC7, 0x00,  //          ###   ###           //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x03, 0xF0, 0x00,  //         ######               //
	     0x03, 0xF0, 0x00,  //         ######               //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x00, 0x00, 0x00,  //                              //

	     // @7656   [z]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7743   [{]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x00, 0x00,  //                              //

	     // @7830   [|]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //

	     // @7917   [}]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x00, 0x00,  //                              //

	     // @8004   [~]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x07, 0xF1, 0x80,  //        #######   ##          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x06, 0x3F, 0x80,  //        ##   #######          //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8091   [â‚¬]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0xC0,  //               ######         //
	     0x00, 0x3F, 0xC0,  //             ########         //
	     0x00, 0x7F, 0xC0,  //            #########         //
	     0x00, 0xF0, 0x40,  //           ####     #         //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xF0, 0x40,  //           ####     #         //
	     0x00, 0x7F, 0xC0,  //            #########         //
	     0x00, 0x3F, 0xC0,  //             ########         //
	     0x00, 0x0F, 0xC0,  //               ######         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8178   [Â�]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8265   [â€°]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x78, 0x30, 0x00,  //    ####     ##               //
	     0x78, 0x60, 0x00,  //    ####    ##                //
	     0xCC, 0x60, 0x00,  //   ##  ##   ##                //
	     0xCC, 0x60, 0x00,  //   ##  ##   ##                //
	     0xCC, 0xC0, 0x00,  //   ##  ##  ##                 //
	     0xCC, 0xC0, 0x00,  //   ##  ##  ##                 //
	     0xCD, 0x80, 0x00,  //   ##  ## ##                  //
	     0x79, 0x80, 0x00,  //    ####  ##                  //
	     0x79, 0x80, 0x00,  //    ####  ##                  //
	     0x03, 0x3C, 0x3C,  //         ##  ####    ####     //
	     0x03, 0x3C, 0x3C,  //         ##  ####    ####     //
	     0x07, 0x66, 0x66,  //        ### ##  ##  ##  ##    //
	     0x06, 0x66, 0x66,  //        ##  ##  ##  ##  ##    //
	     0x06, 0x66, 0x66,  //        ##  ##  ##  ##  ##    //
	     0x0C, 0x66, 0x66,  //       ##   ##  ##  ##  ##    //
	     0x0C, 0x66, 0x66,  //       ##   ##  ##  ##  ##    //
	     0x1C, 0x3C, 0x3C,  //      ###    ####    ####     //
	     0x18, 0x3C, 0x3C,  //      ##     ####    ####     //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8352   [Ĺš]   (23 px wide)
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0xF0, 0x00,  //        #######               //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0F, 0x01, 0xC0,  //       ####       ###         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8439   [â€˘]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8526   [Â�]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8613   [Ĺ›]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x01, 0xC3, 0x80,  //          ###    ###          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8700   [ĹĄ]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x43, 0x80,  //            #    ###          //
	     0x00, 0xC3, 0x80,  //           ##    ###          //
	     0x01, 0xC3, 0x80,  //          ###    ###          //
	     0x01, 0xC1, 0x80,  //          ###     ##          //
	     0x07, 0xF1, 0x00,  //        #######   #           //
	     0x07, 0xF2, 0x00,  //        #######  #            //
	     0x07, 0xF0, 0x00,  //        #######               //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8787   [Ĺş]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8874   [Ĺ�]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x88, 0x00,  //         ###   #              //
	     0x03, 0x98, 0x00,  //         ###  ##              //
	     0x03, 0xB0, 0x00,  //         ### ##               //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x0F, 0x80, 0x00,  //       #####                  //
	     0x0B, 0x80, 0x00,  //       # ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8961   [Ä„]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x01, 0xDC, 0x00,  //          ### ###             //
	     0x01, 0xDC, 0x00,  //          ### ###             //
	     0x03, 0xDE, 0x00,  //         #### ####            //
	     0x03, 0x8E, 0x00,  //         ###   ###            //
	     0x03, 0x8E, 0x00,  //         ###   ###            //
	     0x07, 0x07, 0x00,  //        ###     ###           //
	     0x07, 0x07, 0x00,  //        ###     ###           //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x1C, 0x01, 0xC0,  //      ###         ###         //
	     0x1C, 0x01, 0xC0,  //      ###         ###         //
	     0x1C, 0x01, 0xC0,  //      ###         ###         //
	     0x38, 0x00, 0xE0,  //     ###           ###        //
	     0x00, 0x00, 0xE0,  //                   ###        //
	     0x00, 0x01, 0xC0,  //                  ###         //
	     0x00, 0x01, 0xC0,  //                  ###         //
	     0x00, 0x01, 0xF0,  //                  #####       //
	     0x00, 0x00, 0xF0,  //                   ####       //
	     0x00, 0x00, 0x00,  //                              //

	     // @9048   [Ĺ»]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x0F, 0x00, 0x00,  //       ####                   //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @9135   [Â°]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x01, 0x86, 0x00,  //          ##    ##            //
	     0x01, 0x86, 0x00,  //          ##    ##            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @9222   [Â±]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @9309   [Ĺ‚]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x3A, 0x00,  //             ### #            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xB8, 0x00,  //           # ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @9396   [Âµ]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xBB, 0x80,  //         ### ### ###          //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x00, 0x00, 0x00,  //                              //

	     // @9483   [Ä…]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0x8F, 0x00,  //         ###   ####           //
	     0x07, 0x07, 0x00,  //        ###     ###           //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x3F, 0x00,  //             ######           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xE7, 0x00,  //         #####  ###           //
	     0x07, 0x07, 0x00,  //        ###     ###           //
	     0x07, 0x07, 0x00,  //        ###     ###           //
	     0x07, 0x8F, 0x00,  //        ####   ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xF3, 0x80,  //          #####  ###          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0xC0,  //                #####         //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x00, 0x00, 0x00,  //                              //

	     // @9570   [ĹĽ]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @9657   [Ä†]   (23 px wide)
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x07, 0x83, 0xE0,  //        ####     #####        //
	     0x07, 0x00, 0xC0,  //        ###        ##         //
	     0x0F, 0x00, 0x00,  //       ####                   //
	     0x0E, 0x00, 0x00,  //       ###                    //
	     0x0E, 0x00, 0x00,  //       ###                    //
	     0x0E, 0x00, 0x00,  //       ###                    //
	     0x0E, 0x00, 0x00,  //       ###                    //
	     0x0E, 0x00, 0x00,  //       ###                    //
	     0x0F, 0x00, 0x00,  //       ####                   //
	     0x07, 0x00, 0xC0,  //        ###        ##         //
	     0x07, 0x83, 0xE0,  //        ####     #####        //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @9744   [Ä�]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0x00, 0x00,  //        ###                   //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0xC0,  //                #####         //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x00, 0x00, 0x00,  //                              //

	     // @9831   [Ĺ�]   (23 px wide)
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x81, 0xC0,  //        ####      ###         //
	     0x07, 0xC1, 0xC0,  //        #####     ###         //
	     0x07, 0xC1, 0xC0,  //        #####     ###         //
	     0x07, 0xE1, 0xC0,  //        ######    ###         //
	     0x07, 0xE1, 0xC0,  //        ######    ###         //
	     0x07, 0x71, 0xC0,  //        ### ###   ###         //
	     0x07, 0x71, 0xC0,  //        ### ###   ###         //
	     0x07, 0x39, 0xC0,  //        ###  ###  ###         //
	     0x07, 0x3D, 0xC0,  //        ###  #### ###         //
	     0x07, 0x1D, 0xC0,  //        ###   ### ###         //
	     0x07, 0x0F, 0xC0,  //        ###    ######         //
	     0x07, 0x0F, 0xC0,  //        ###    ######         //
	     0x07, 0x07, 0xC0,  //        ###     #####         //
	     0x07, 0x07, 0xC0,  //        ###     #####         //
	     0x07, 0x03, 0xC0,  //        ###      ####         //
	     0x07, 0x03, 0xC0,  //        ###      ####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @9918   [Ă“]   (23 px wide)
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x1E, 0x01, 0xE0,  //      ####        ####        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1C, 0x00, 0xE0,  //      ###          ###        //
	     0x1E, 0x01, 0xE0,  //      ####        ####        //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @10005   [Ă—]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0x02, 0x00,  //          #      #            //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x01, 0x02, 0x00,  //          #      #            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @10092   [Ăź]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0x8E, 0x00,  //        ####   ###            //
	     0x07, 0x0E, 0x00,  //        ###    ###            //
	     0x07, 0x1C, 0x00,  //        ###   ###             //
	     0x07, 0x18, 0x00,  //        ###   ##              //
	     0x07, 0x38, 0x00,  //        ###  ###              //
	     0x07, 0x3C, 0x00,  //        ###  ####             //
	     0x07, 0x1E, 0x00,  //        ###   ####            //
	     0x07, 0x0F, 0x00,  //        ###    ####           //
	     0x07, 0x07, 0x80,  //        ###     ####          //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x07, 0x23, 0x80,  //        ###  #   ###          //
	     0x07, 0x7F, 0x80,  //        ### ########          //
	     0x07, 0x3F, 0x00,  //        ###  ######           //
	     0x07, 0x1E, 0x00,  //        ###   ####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @10179   [Ä‡]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0x83, 0x00,  //         ###     ##           //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x83, 0x00,  //         ###     ##           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @10266   [Ä™]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC7, 0x00,  //         ####   ###           //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x03, 0x80, 0x00,  //         ###                  //
	     0x01, 0xC3, 0x80,  //          ###    ###          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x00, 0x00,  //                              //

	     // @10353   [Ĺ„]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0x9E, 0x00,  //         ###  ####            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x03, 0x83, 0x80,  //         ###     ###          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @10440   [Ăł]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x01, 0xC0,  //        ###       ###         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

		 /*
	     // @10527   [Ă·]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     */
		 // @10527   [Ă·]   (23 px wide)
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //        SPACJA POD ADRESEM    //
		 	     0x00, 0x00, 0x00,  //              247             //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //             ###              //
		 	     0x00, 0x00, 0x00,  //             ###              //
		 	     0x00, 0x00, 0x00,  //             ###              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //         ###########          //
		 	     0x00, 0x00, 0x00,  //         ###########          //
		 	     0x00, 0x00, 0x00,  //         ###########          //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //             ###              //
		 	     0x00, 0x00, 0x00,  //             ###              //
		 	     0x00, 0x00, 0x00,  //             ###              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
		 	     0x00, 0x00, 0x00,  //                              //
};
const uint16_t font4desc[]=
{
		     0 ,		// !  (33)
		    87 ,		// "  (34)
		    174 ,		// #  (35)
		    261 ,		// $  (36)
		    348 ,		// %  (37)
		    435 ,		// &  (38)
		    522 ,		// '  (39)
		    609 ,		// (  (40)
		    696 ,		// )  (41)
		    783 ,		// *  (42)
		    870 ,		// +  (43)
		    957 ,		// ,  (44)
		    1044 ,		// -  (45)
		    1131 ,		// .  (46)
		    1218 ,		// /  (47)
		    1305 ,		// 0  (48)
		    1392 ,		// 1  (49)
		    1479 ,		// 2  (50)
		    1566 ,		// 3  (51)
		    1653 ,		// 4  (52)
		    1740 ,		// 5  (53)
		    1827 ,		// 6  (54)
		    1914 ,		// 7  (55)
		    2001 ,		// 8  (56)
		    2088 ,		// 9  (57)
		    2175 ,		// :  (58)
		    2262 ,		// ;  (59)
		    2349 ,		// <  (60)
		    2436 ,		// =  (61)
		    2523 ,		// >  (62)
		    2610 ,		// ?  (63)
		    2697 ,		// @  (64)
		    2784 ,		// A  (65)
		    2871 ,		// B  (66)
		    2958 ,		// C  (67)
		    3045 ,		// D  (68)
		    3132 ,		// E  (69)
		    3219 ,		// F  (70)
		    3306 ,		// G  (71)
		    3393 ,		// H  (72)
		    3480 ,		// I  (73)
		    3567 ,		// J  (74)
		    3654 ,		// K  (75)
		    3741 ,		// L  (76)
		    3828 ,		// M  (77)
		    3915 ,		// N  (78)
		    4002 ,		// O  (79)
		    4089 ,		// P  (80)
		    4176 ,		// Q  (81)
		    4263 ,		// R  (82)
		    4350 ,		// S  (83)
		    4437 ,		// T  (84)
		    4524 ,		// U  (85)
		    4611 ,		// V  (86)
		    4698 ,		// W  (87)
		    4785 ,		// X  (88)
		    4872 ,		// Y  (89)
		    4959 ,		// Z  (90)
		    5046 ,		// [  (91)
		    5133 ,		// //  (92)
		    5220 ,		// ]  (93)
		    5307 ,		// ^  (94)
		    5394 ,		// _  (95)
		    0 ,		// `
		    5481 ,		// a  (97)
		    5568 ,		// b  (98)
		    5655 ,		// c  (99)
		    5742 ,		// d  (100)
		    5829 ,		// e  (101)
		    5916 ,		// f  (102)
		    6003 ,		// g  (103)
		    6090 ,		// h  (104)
		    6177 ,		// i  (105)
		    6264 ,		// j  (106)
		    6351 ,		// k  (107)
		    6438 ,		// l  (108)
		    6525 ,		// m  (109)
		    6612 ,		// n  (110)
		    6699 ,		// o  (111)
		    6786 ,		// p  (112)
		    6873 ,		// q  (113)
		    6960 ,		// r  (114)
		    7047 ,		// s  (115)
		    7134 ,		// t  (116)
		    7221 ,		// u  (117)
		    7308 ,		// v  (118)
		    7395 ,		// w  (119)
		    7482 ,		// x  (120)
		    7569 ,		// y  (121)
		    7656 ,		// z  (122)
		    7743 ,		// {  (123)
		    7830 ,		// |  (124)
		    7917 ,		// }  (125)
		    8004 ,		// ~  (126)
		    0 ,		//
		    8091 ,		//    (128)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    8178 ,		//    (136)
		    8265 ,		//    (137)
		    0 ,		//
		    0 ,		//
		    8352 ,		// Ĺš  (140)
		    0 ,		//
		    0 ,		//
		    0 ,		// Ĺą
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    8439 ,		//    (149)
		    0 ,		//
		    0 ,		//
		    8526 ,		//    (152)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    8613 ,		// Ĺ›  (156)
		    8700 ,		//    (157)
		    0 ,		//
		    8787 ,		// Ĺş  (159)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    8874 ,		// Ĺ�  (163)
		    0 ,		//
		    8961 ,		// Ä„  (165)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    9048 ,		// Ĺ»  (175)
		    9135 ,		//    (176)
		    9222 ,		//    (177)
		    0 ,		//
		    9309 ,		// Ĺ‚  (179)
		    0 ,		//
		    9396 ,		//    (181)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    9483 ,		// Ä…  (185)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    9570 ,		// ĹĽ  (191)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    9657 ,		// Ä†  (198)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    9744 ,		// Ä�  (202)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    9831 ,		// Ĺ�  (209)
		    0 ,		//
		    9918 ,		// Ă“  (211)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    10005 ,		//    (215)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    10092 ,		//    (223)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    10179 ,		// Ä‡  (230)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    10266 ,		// Ä™  (234)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    10353 ,		// Ĺ„  (241)
		    0 ,		//
		    10440 ,		// Ăł  (243)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    10527 ,		//    (247)
};


const uint8_t fontinfo4[]=
{
		29,  // Character height
		    '!',  //  Start character
		    0,  //  number of pixels of interspace between characters
		    2,  // number of pixels of space character

};

const uint8_t font5[]=
{
	     // @0   [,]   (33 px wide)
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x00, 0x70, 0x00, 0x00,  //                    ###                 //
	     0x00, 0x00, 0x70, 0x00, 0x00,  //                    ###                 //
	     0x00, 0x00, 0xF0, 0x00, 0x00,  //                   ####                 //
	     0x00, 0x01, 0xE0, 0x00, 0x00,  //                  ####                  //
	     0x00, 0x03, 0xE0, 0x00, 0x00,  //                 #####                  //
	     0x00, 0x0F, 0xC0, 0x00, 0x00,  //               ######                   //
	     0x00, 0x07, 0x80, 0x00, 0x00,  //                ####                    //
	     0x00, 0x06, 0x00, 0x00, 0x00,  //                ##                      //

	     // @215   [0]   (33 px wide)
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x1F, 0xFC, 0x00, 0x00,  //              ###########               //
	     0x00, 0x7F, 0xFF, 0x00, 0x00,  //            ###############             //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x01, 0xFF, 0xFF, 0xC0, 0x00,  //          ###################           //
	     0x01, 0xFE, 0x3F, 0xC0, 0x00,  //          ########   ########           //
	     0x03, 0xFC, 0x1F, 0xE0, 0x00,  //         ########     ########          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF0, 0x07, 0xE0, 0x00,  //         ######         ######          //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x03, 0xF0, 0x07, 0xE0, 0x00,  //         ######         ######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xFC, 0x1F, 0xE0, 0x00,  //         ########     ########          //
	     0x01, 0xFE, 0x3F, 0xC0, 0x00,  //          ########   ########           //
	     0x01, 0xFF, 0xFF, 0xC0, 0x00,  //          ###################           //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x00, 0x7F, 0xFF, 0x00, 0x00,  //            ###############             //
	     0x00, 0x1F, 0xFC, 0x00, 0x00,  //              ###########               //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @430   [1]   (33 px wide)
	     0x00, 0x00, 0x3F, 0x00, 0x00,  //                     ######             //
	     0x00, 0x00, 0x3F, 0x00, 0x00,  //                     ######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0xFF, 0x00, 0x00,  //                   ########             //
	     0x00, 0x01, 0xFF, 0x00, 0x00,  //                  #########             //
	     0x00, 0x03, 0xFF, 0x00, 0x00,  //                 ##########             //
	     0x00, 0x07, 0xFF, 0x00, 0x00,  //                ###########             //
	     0x00, 0x1F, 0xFF, 0x00, 0x00,  //              #############             //
	     0x00, 0x7F, 0xFF, 0x00, 0x00,  //            ###############             //
	     0x00, 0xFF, 0xFF, 0x00, 0x00,  //           ################             //
	     0x00, 0xFF, 0x7F, 0x00, 0x00,  //           ######## #######             //
	     0x00, 0xFE, 0x7F, 0x00, 0x00,  //           #######  #######             //
	     0x00, 0xFC, 0x7F, 0x00, 0x00,  //           ######   #######             //
	     0x00, 0xF0, 0x7F, 0x00, 0x00,  //           ####     #######             //
	     0x00, 0x80, 0x7F, 0x00, 0x00,  //           #        #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @645   [2]   (33 px wide)
	     0x00, 0x07, 0xF8, 0x00, 0x00,  //                ########                //
	     0x00, 0x1F, 0xFF, 0x00, 0x00,  //              #############             //
	     0x00, 0x3F, 0xFF, 0x80, 0x00,  //             ###############            //
	     0x00, 0x7F, 0xFF, 0xC0, 0x00,  //            #################           //
	     0x00, 0xFF, 0xFF, 0xE0, 0x00,  //           ###################          //
	     0x01, 0xFF, 0xFF, 0xE0, 0x00,  //          ####################          //
	     0x01, 0xFE, 0x1F, 0xF0, 0x00,  //          ########    #########         //
	     0x01, 0xFC, 0x0F, 0xF0, 0x00,  //          #######      ########         //
	     0x03, 0xF8, 0x07, 0xF0, 0x00,  //         #######        #######         //
	     0x03, 0xF8, 0x07, 0xF0, 0x00,  //         #######        #######         //
	     0x01, 0xF8, 0x07, 0xF0, 0x00,  //          ######        #######         //
	     0x00, 0x00, 0x07, 0xF0, 0x00,  //                        #######         //
	     0x00, 0x00, 0x07, 0xF0, 0x00,  //                        #######         //
	     0x00, 0x00, 0x0F, 0xE0, 0x00,  //                       #######          //
	     0x00, 0x00, 0x0F, 0xE0, 0x00,  //                       #######          //
	     0x00, 0x00, 0x1F, 0xC0, 0x00,  //                      #######           //
	     0x00, 0x00, 0x3F, 0xC0, 0x00,  //                     ########           //
	     0x00, 0x00, 0x7F, 0x80, 0x00,  //                    ########            //
	     0x00, 0x00, 0xFF, 0x00, 0x00,  //                   ########             //
	     0x00, 0x01, 0xFE, 0x00, 0x00,  //                  ########              //
	     0x00, 0x03, 0xFC, 0x00, 0x00,  //                 ########               //
	     0x00, 0x07, 0xF8, 0x00, 0x00,  //                ########                //
	     0x00, 0x0F, 0xF0, 0x00, 0x00,  //               ########                 //
	     0x00, 0x1F, 0xE0, 0x00, 0x00,  //              ########                  //
	     0x00, 0x3F, 0xC0, 0x00, 0x00,  //             ########                   //
	     0x00, 0x7F, 0x80, 0x00, 0x00,  //            ########                    //
	     0x00, 0x7F, 0x00, 0x00, 0x00,  //            #######                     //
	     0x00, 0xFE, 0x00, 0x00, 0x00,  //           #######                      //
	     0x01, 0xFF, 0xFF, 0xF0, 0x00,  //          #####################         //
	     0x01, 0xFF, 0xFF, 0xF0, 0x00,  //          #####################         //
	     0x03, 0xFF, 0xFF, 0xF0, 0x00,  //         ######################         //
	     0x03, 0xFF, 0xFF, 0xF0, 0x00,  //         ######################         //
	     0x07, 0xFF, 0xFF, 0xF0, 0x00,  //        #######################         //
	     0x07, 0xFF, 0xFF, 0xF0, 0x00,  //        #######################         //
	     0x07, 0xFF, 0xFF, 0xF0, 0x00,  //        #######################         //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @860   [3]   (33 px wide)
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x1F, 0xFC, 0x00, 0x00,  //              ###########               //
	     0x00, 0x7F, 0xFE, 0x00, 0x00,  //            ##############              //
	     0x00, 0xFF, 0xFF, 0x00, 0x00,  //           ################             //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x01, 0xFF, 0xFF, 0x80, 0x00,  //          ##################            //
	     0x01, 0xFE, 0x3F, 0xC0, 0x00,  //          ########   ########           //
	     0x03, 0xFC, 0x1F, 0xC0, 0x00,  //         ########     #######           //
	     0x03, 0xF8, 0x1F, 0xC0, 0x00,  //         #######      #######           //
	     0x00, 0x78, 0x1F, 0xC0, 0x00,  //            ####      #######           //
	     0x00, 0x00, 0x1F, 0xC0, 0x00,  //                      #######           //
	     0x00, 0x00, 0x3F, 0x80, 0x00,  //                     #######            //
	     0x00, 0x00, 0x7F, 0x80, 0x00,  //                    ########            //
	     0x00, 0x01, 0xFF, 0x00, 0x00,  //                  #########             //
	     0x00, 0x03, 0xFC, 0x00, 0x00,  //                 ########               //
	     0x00, 0x03, 0xF8, 0x00, 0x00,  //                 #######                //
	     0x00, 0x03, 0xFF, 0x00, 0x00,  //                 ##########             //
	     0x00, 0x03, 0xFF, 0x80, 0x00,  //                 ###########            //
	     0x00, 0x00, 0x1F, 0xC0, 0x00,  //                      #######           //
	     0x00, 0x00, 0x0F, 0xE0, 0x00,  //                       #######          //
	     0x00, 0x00, 0x0F, 0xE0, 0x00,  //                       #######          //
	     0x00, 0x00, 0x07, 0xF0, 0x00,  //                        #######         //
	     0x00, 0x00, 0x07, 0xF0, 0x00,  //                        #######         //
	     0x00, 0x00, 0x07, 0xF0, 0x00,  //                        #######         //
	     0x01, 0xF0, 0x07, 0xF0, 0x00,  //          #####         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF8, 0x0F, 0xF0, 0x00,  //        ########       ########         //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xFE, 0x3F, 0xE0, 0x00,  //         #########   #########          //
	     0x03, 0xFF, 0xFF, 0xC0, 0x00,  //         ####################           //
	     0x01, 0xFF, 0xFF, 0xC0, 0x00,  //          ###################           //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x00, 0x7F, 0xFF, 0x00, 0x00,  //            ###############             //
	     0x00, 0x3F, 0xFC, 0x00, 0x00,  //             ############               //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @1075   [4]   (33 px wide)
	     0x00, 0x00, 0x1F, 0x80, 0x00,  //                      ######            //
	     0x00, 0x00, 0x3F, 0x80, 0x00,  //                     #######            //
	     0x00, 0x00, 0x7F, 0x80, 0x00,  //                    ########            //
	     0x00, 0x00, 0x7F, 0x80, 0x00,  //                    ########            //
	     0x00, 0x00, 0xFF, 0x80, 0x00,  //                   #########            //
	     0x00, 0x01, 0xFF, 0x80, 0x00,  //                  ##########            //
	     0x00, 0x01, 0xFF, 0x80, 0x00,  //                  ##########            //
	     0x00, 0x03, 0xFF, 0x80, 0x00,  //                 ###########            //
	     0x00, 0x07, 0xFF, 0x80, 0x00,  //                ############            //
	     0x00, 0x0F, 0xFF, 0x80, 0x00,  //               #############            //
	     0x00, 0x0F, 0xFF, 0x80, 0x00,  //               #############            //
	     0x00, 0x1F, 0xBF, 0x80, 0x00,  //              ###### #######            //
	     0x00, 0x3F, 0x3F, 0x80, 0x00,  //             ######  #######            //
	     0x00, 0x3F, 0x3F, 0x80, 0x00,  //             ######  #######            //
	     0x00, 0x7E, 0x3F, 0x80, 0x00,  //            ######   #######            //
	     0x00, 0xFC, 0x3F, 0x80, 0x00,  //           ######    #######            //
	     0x00, 0xFC, 0x3F, 0x80, 0x00,  //           ######    #######            //
	     0x01, 0xF8, 0x3F, 0x80, 0x00,  //          ######     #######            //
	     0x03, 0xF0, 0x3F, 0x80, 0x00,  //         ######      #######            //
	     0x03, 0xF0, 0x3F, 0x80, 0x00,  //         ######      #######            //
	     0x07, 0xE0, 0x3F, 0x80, 0x00,  //        ######       #######            //
	     0x0F, 0xC0, 0x3F, 0x80, 0x00,  //       ######        #######            //
	     0x0F, 0xFF, 0xFF, 0xF8, 0x00,  //       #########################        //
	     0x0F, 0xFF, 0xFF, 0xF8, 0x00,  //       #########################        //
	     0x0F, 0xFF, 0xFF, 0xF8, 0x00,  //       #########################        //
	     0x0F, 0xFF, 0xFF, 0xF8, 0x00,  //       #########################        //
	     0x0F, 0xFF, 0xFF, 0xF8, 0x00,  //       #########################        //
	     0x0F, 0xFF, 0xFF, 0xF8, 0x00,  //       #########################        //
	     0x00, 0x00, 0x3F, 0x80, 0x00,  //                     #######            //
	     0x00, 0x00, 0x3F, 0x80, 0x00,  //                     #######            //
	     0x00, 0x00, 0x3F, 0x80, 0x00,  //                     #######            //
	     0x00, 0x00, 0x3F, 0x80, 0x00,  //                     #######            //
	     0x00, 0x00, 0x3F, 0x80, 0x00,  //                     #######            //
	     0x00, 0x00, 0x3F, 0x80, 0x00,  //                     #######            //
	     0x00, 0x00, 0x3F, 0x80, 0x00,  //                     #######            //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @1290   [5]   (33 px wide)
	     0x00, 0x3F, 0xFF, 0xC0, 0x00,  //             ################           //
	     0x00, 0x3F, 0xFF, 0xC0, 0x00,  //             ################           //
	     0x00, 0x3F, 0xFF, 0xC0, 0x00,  //             ################           //
	     0x00, 0x7F, 0xFF, 0xC0, 0x00,  //            #################           //
	     0x00, 0x7F, 0xFF, 0xC0, 0x00,  //            #################           //
	     0x00, 0x7F, 0xFF, 0xC0, 0x00,  //            #################           //
	     0x00, 0x7F, 0xFF, 0xC0, 0x00,  //            #################           //
	     0x00, 0x7F, 0x00, 0x00, 0x00,  //            #######                     //
	     0x00, 0xFE, 0x00, 0x00, 0x00,  //           #######                      //
	     0x00, 0xFE, 0x00, 0x00, 0x00,  //           #######                      //
	     0x00, 0xFE, 0x00, 0x00, 0x00,  //           #######                      //
	     0x00, 0xFE, 0x00, 0x00, 0x00,  //           #######                      //
	     0x00, 0xFE, 0xF8, 0x00, 0x00,  //           ####### #####                //
	     0x01, 0xFF, 0xFE, 0x00, 0x00,  //          ################              //
	     0x01, 0xFF, 0xFF, 0x80, 0x00,  //          ##################            //
	     0x01, 0xFF, 0xFF, 0xC0, 0x00,  //          ###################           //
	     0x01, 0xFF, 0xFF, 0xC0, 0x00,  //          ###################           //
	     0x01, 0xFF, 0xFF, 0xE0, 0x00,  //          ####################          //
	     0x03, 0xFE, 0x1F, 0xE0, 0x00,  //         #########    ########          //
	     0x03, 0xF8, 0x0F, 0xF0, 0x00,  //         #######       ########         //
	     0x00, 0x70, 0x07, 0xF0, 0x00,  //            ###         #######         //
	     0x00, 0x00, 0x07, 0xF0, 0x00,  //                        #######         //
	     0x00, 0x00, 0x07, 0xF0, 0x00,  //                        #######         //
	     0x00, 0x00, 0x07, 0xF0, 0x00,  //                        #######         //
	     0x01, 0xF0, 0x07, 0xF0, 0x00,  //          #####         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF8, 0x0F, 0xF0, 0x00,  //        ########       ########         //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xFE, 0x1F, 0xE0, 0x00,  //         #########    ########          //
	     0x03, 0xFF, 0xFF, 0xC0, 0x00,  //         ####################           //
	     0x01, 0xFF, 0xFF, 0xC0, 0x00,  //          ###################           //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x00, 0x7F, 0xFF, 0x00, 0x00,  //            ###############             //
	     0x00, 0x3F, 0xFC, 0x00, 0x00,  //             ############               //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @1505   [6]   (33 px wide)
	     0x00, 0x03, 0xF8, 0x00, 0x00,  //                 #######                //
	     0x00, 0x0F, 0xFE, 0x00, 0x00,  //               ###########              //
	     0x00, 0x3F, 0xFF, 0x00, 0x00,  //             ##############             //
	     0x00, 0x7F, 0xFF, 0x80, 0x00,  //            ################            //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x00, 0xFF, 0xFF, 0xC0, 0x00,  //           ##################           //
	     0x01, 0xFE, 0x3F, 0xC0, 0x00,  //          ########   ########           //
	     0x01, 0xFC, 0x1F, 0xE0, 0x00,  //          #######     ########          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF0, 0x0F, 0x80, 0x00,  //         ######        #####            //
	     0x03, 0xF0, 0x00, 0x00, 0x00,  //         ######                         //
	     0x07, 0xF0, 0x00, 0x00, 0x00,  //        #######                         //
	     0x07, 0xF0, 0x00, 0x00, 0x00,  //        #######                         //
	     0x07, 0xF1, 0xF8, 0x00, 0x00,  //        #######   ######                //
	     0x07, 0xF7, 0xFE, 0x00, 0x00,  //        ####### ##########              //
	     0x07, 0xEF, 0xFF, 0x00, 0x00,  //        ###### ############             //
	     0x07, 0xFF, 0xFF, 0x80, 0x00,  //        ####################            //
	     0x07, 0xFF, 0xFF, 0xC0, 0x00,  //        #####################           //
	     0x07, 0xFF, 0xFF, 0xE0, 0x00,  //        ######################          //
	     0x07, 0xFC, 0x1F, 0xE0, 0x00,  //        #########     ########          //
	     0x07, 0xF8, 0x0F, 0xF0, 0x00,  //        ########       ########         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x03, 0xF0, 0x07, 0xF0, 0x00,  //         ######         #######         //
	     0x03, 0xF0, 0x07, 0xF0, 0x00,  //         ######         #######         //
	     0x03, 0xF8, 0x07, 0xF0, 0x00,  //         #######        #######         //
	     0x03, 0xF8, 0x0F, 0xF0, 0x00,  //         #######       ########         //
	     0x01, 0xFE, 0x1F, 0xE0, 0x00,  //          ########    ########          //
	     0x01, 0xFF, 0xFF, 0xE0, 0x00,  //          ####################          //
	     0x00, 0xFF, 0xFF, 0xC0, 0x00,  //           ##################           //
	     0x00, 0x7F, 0xFF, 0x80, 0x00,  //            ################            //
	     0x00, 0x3F, 0xFF, 0x00, 0x00,  //             ##############             //
	     0x00, 0x1F, 0xFE, 0x00, 0x00,  //              ############              //
	     0x00, 0x07, 0xF8, 0x00, 0x00,  //                ########                //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @1720   [7]   (33 px wide)
	     0x07, 0xFF, 0xFF, 0xF0, 0x00,  //        #######################         //
	     0x07, 0xFF, 0xFF, 0xF0, 0x00,  //        #######################         //
	     0x07, 0xFF, 0xFF, 0xF0, 0x00,  //        #######################         //
	     0x07, 0xFF, 0xFF, 0xF0, 0x00,  //        #######################         //
	     0x07, 0xFF, 0xFF, 0xF0, 0x00,  //        #######################         //
	     0x07, 0xFF, 0xFF, 0xF0, 0x00,  //        #######################         //
	     0x07, 0xFF, 0xFF, 0xE0, 0x00,  //        ######################          //
	     0x00, 0x00, 0x0F, 0xC0, 0x00,  //                       ######           //
	     0x00, 0x00, 0x1F, 0x80, 0x00,  //                      ######            //
	     0x00, 0x00, 0x3F, 0x00, 0x00,  //                     ######             //
	     0x00, 0x00, 0x7F, 0x00, 0x00,  //                    #######             //
	     0x00, 0x00, 0x7E, 0x00, 0x00,  //                    ######              //
	     0x00, 0x00, 0xFC, 0x00, 0x00,  //                   ######               //
	     0x00, 0x00, 0xFC, 0x00, 0x00,  //                   ######               //
	     0x00, 0x01, 0xF8, 0x00, 0x00,  //                  ######                //
	     0x00, 0x03, 0xF8, 0x00, 0x00,  //                 #######                //
	     0x00, 0x03, 0xF0, 0x00, 0x00,  //                 ######                 //
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x07, 0xE0, 0x00, 0x00,  //                ######                  //
	     0x00, 0x07, 0xE0, 0x00, 0x00,  //                ######                  //
	     0x00, 0x0F, 0xE0, 0x00, 0x00,  //               #######                  //
	     0x00, 0x0F, 0xC0, 0x00, 0x00,  //               ######                   //
	     0x00, 0x1F, 0xC0, 0x00, 0x00,  //              #######                   //
	     0x00, 0x1F, 0xC0, 0x00, 0x00,  //              #######                   //
	     0x00, 0x1F, 0xC0, 0x00, 0x00,  //              #######                   //
	     0x00, 0x3F, 0x80, 0x00, 0x00,  //             #######                    //
	     0x00, 0x3F, 0x80, 0x00, 0x00,  //             #######                    //
	     0x00, 0x3F, 0x80, 0x00, 0x00,  //             #######                    //
	     0x00, 0x3F, 0x80, 0x00, 0x00,  //             #######                    //
	     0x00, 0x3F, 0x00, 0x00, 0x00,  //             ######                     //
	     0x00, 0x7F, 0x00, 0x00, 0x00,  //            #######                     //
	     0x00, 0x7F, 0x00, 0x00, 0x00,  //            #######                     //
	     0x00, 0x7F, 0x00, 0x00, 0x00,  //            #######                     //
	     0x00, 0x7F, 0x00, 0x00, 0x00,  //            #######                     //
	     0x00, 0x7F, 0x00, 0x00, 0x00,  //            #######                     //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @1935   [8]   (33 px wide)
	     0x00, 0x07, 0xF0, 0x00, 0x00,  //                #######                 //
	     0x00, 0x3F, 0xFE, 0x00, 0x00,  //             #############              //
	     0x00, 0x7F, 0xFF, 0x00, 0x00,  //            ###############             //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x01, 0xFF, 0xFF, 0xC0, 0x00,  //          ###################           //
	     0x01, 0xFE, 0x3F, 0xC0, 0x00,  //          ########   ########           //
	     0x03, 0xFC, 0x1F, 0xE0, 0x00,  //         ########     ########          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x01, 0xFC, 0x1F, 0xC0, 0x00,  //          #######     #######           //
	     0x01, 0xFE, 0x3F, 0xC0, 0x00,  //          ########   ########           //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x00, 0x3F, 0xFE, 0x00, 0x00,  //             #############              //
	     0x00, 0x1F, 0xFC, 0x00, 0x00,  //              ###########               //
	     0x00, 0x7F, 0xFF, 0x00, 0x00,  //            ###############             //
	     0x00, 0xFF, 0xFF, 0x80, 0x00,  //           #################            //
	     0x01, 0xFC, 0x1F, 0xC0, 0x00,  //          #######     #######           //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF8, 0x0F, 0xF0, 0x00,  //        ########       ########         //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xFE, 0x1F, 0xE0, 0x00,  //         #########    ########          //
	     0x01, 0xFF, 0xFF, 0xC0, 0x00,  //          ###################           //
	     0x00, 0xFF, 0xFF, 0xC0, 0x00,  //           ##################           //
	     0x00, 0x7F, 0xFF, 0x00, 0x00,  //            ###############             //
	     0x00, 0x3F, 0xFE, 0x00, 0x00,  //             #############              //
	     0x00, 0x07, 0xF8, 0x00, 0x00,  //                ########                //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @2150   [9]   (33 px wide)
	     0x00, 0x0F, 0xF0, 0x00, 0x00,  //               ########                 //
	     0x00, 0x3F, 0xFC, 0x00, 0x00,  //             ############               //
	     0x00, 0x7F, 0xFE, 0x00, 0x00,  //            ##############              //
	     0x00, 0xFF, 0xFF, 0x00, 0x00,  //           ################             //
	     0x01, 0xFF, 0xFF, 0x80, 0x00,  //          ##################            //
	     0x03, 0xFF, 0xFF, 0xC0, 0x00,  //         ####################           //
	     0x03, 0xFC, 0x3F, 0xC0, 0x00,  //         ########    ########           //
	     0x07, 0xF8, 0x0F, 0xE0, 0x00,  //        ########       #######          //
	     0x07, 0xF0, 0x0F, 0xE0, 0x00,  //        #######        #######          //
	     0x07, 0xF0, 0x07, 0xE0, 0x00,  //        #######         ######          //
	     0x07, 0xF0, 0x07, 0xE0, 0x00,  //        #######         ######          //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF8, 0x0F, 0xF0, 0x00,  //        ########       ########         //
	     0x03, 0xFC, 0x1F, 0xF0, 0x00,  //         ########     #########         //
	     0x03, 0xFF, 0xFF, 0xF0, 0x00,  //         ######################         //
	     0x01, 0xFF, 0xFF, 0xF0, 0x00,  //          #####################         //
	     0x00, 0xFF, 0xFF, 0xF0, 0x00,  //           ####################         //
	     0x00, 0x7F, 0xFB, 0xF0, 0x00,  //            ############ ######         //
	     0x00, 0x3F, 0xF7, 0xF0, 0x00,  //             ########## #######         //
	     0x00, 0x0F, 0xC7, 0xF0, 0x00,  //               ######   #######         //
	     0x00, 0x00, 0x07, 0xF0, 0x00,  //                        #######         //
	     0x00, 0x00, 0x07, 0xF0, 0x00,  //                        #######         //
	     0x00, 0x00, 0x07, 0xE0, 0x00,  //                        ######          //
	     0x00, 0xF8, 0x07, 0xE0, 0x00,  //           #####        ######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xFC, 0x0F, 0xC0, 0x00,  //         ########      ######           //
	     0x01, 0xFE, 0x3F, 0xC0, 0x00,  //          ########   ########           //
	     0x01, 0xFF, 0xFF, 0xC0, 0x00,  //          ###################           //
	     0x01, 0xFF, 0xFF, 0x80, 0x00,  //          ##################            //
	     0x00, 0xFF, 0xFF, 0x00, 0x00,  //           ################             //
	     0x00, 0x7F, 0xFE, 0x00, 0x00,  //            ##############              //
	     0x00, 0x3F, 0xF8, 0x00, 0x00,  //             ###########                //
	     0x00, 0x0F, 0xE0, 0x00, 0x00,  //               #######                  //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @2365   [A]   (33 px wide)
	     0x00, 0x0F, 0xF8, 0x00, 0x00,  //               #########                //
	     0x00, 0x1F, 0xF8, 0x00, 0x00,  //              ##########                //
	     0x00, 0x1F, 0xFC, 0x00, 0x00,  //              ###########               //
	     0x00, 0x1F, 0xFC, 0x00, 0x00,  //              ###########               //
	     0x00, 0x3F, 0xFE, 0x00, 0x00,  //             #############              //
	     0x00, 0x3F, 0xFE, 0x00, 0x00,  //             #############              //
	     0x00, 0x3F, 0x7E, 0x00, 0x00,  //             ###### ######              //
	     0x00, 0x7F, 0x7F, 0x00, 0x00,  //            ####### #######             //
	     0x00, 0x7F, 0x7F, 0x00, 0x00,  //            ####### #######             //
	     0x00, 0x7E, 0x3F, 0x00, 0x00,  //            ######   ######             //
	     0x00, 0xFE, 0x3F, 0x80, 0x00,  //           #######   #######            //
	     0x00, 0xFE, 0x3F, 0x80, 0x00,  //           #######   #######            //
	     0x00, 0xFC, 0x1F, 0x80, 0x00,  //           ######     ######            //
	     0x01, 0xFC, 0x1F, 0xC0, 0x00,  //          #######     #######           //
	     0x01, 0xFC, 0x1F, 0xC0, 0x00,  //          #######     #######           //
	     0x01, 0xFC, 0x1F, 0xC0, 0x00,  //          #######     #######           //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xFF, 0xFF, 0xF0, 0x00,  //        #######################         //
	     0x0F, 0xFF, 0xFF, 0xF8, 0x00,  //       #########################        //
	     0x0F, 0xFF, 0xFF, 0xF8, 0x00,  //       #########################        //
	     0x0F, 0xFF, 0xFF, 0xF8, 0x00,  //       #########################        //
	     0x1F, 0xFF, 0xFF, 0xFC, 0x00,  //      ###########################       //
	     0x1F, 0xFF, 0xFF, 0xFC, 0x00,  //      ###########################       //
	     0x1F, 0xC0, 0x01, 0xFC, 0x00,  //      #######             #######       //
	     0x3F, 0x80, 0x00, 0xFE, 0x00,  //     #######               #######      //
	     0x3F, 0x80, 0x00, 0xFE, 0x00,  //     #######               #######      //
	     0x3F, 0x80, 0x00, 0xFE, 0x00,  //     #######               #######      //
	     0x7F, 0x80, 0x00, 0x7F, 0x00,  //    ########                #######     //
	     0x7F, 0x00, 0x00, 0x7F, 0x00,  //    #######                 #######     //
	     0x7F, 0x00, 0x00, 0x7F, 0x00,  //    #######                 #######     //
	     0xFF, 0x00, 0x00, 0x7F, 0x80,  //   ########                 ########    //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //

	     // @2580   [V]   (33 px wide)
	     0x7F, 0x00, 0x00, 0x7F, 0x00,  //    #######                 #######     //
	     0x7F, 0x80, 0x00, 0xFF, 0x00,  //    ########               ########     //
	     0x3F, 0x80, 0x00, 0xFE, 0x00,  //     #######               #######      //
	     0x3F, 0x80, 0x00, 0xFE, 0x00,  //     #######               #######      //
	     0x3F, 0xC0, 0x01, 0xFE, 0x00,  //     ########             ########      //
	     0x1F, 0xC0, 0x01, 0xFC, 0x00,  //      #######             #######       //
	     0x1F, 0xC0, 0x01, 0xFC, 0x00,  //      #######             #######       //
	     0x1F, 0xE0, 0x01, 0xFC, 0x00,  //      ########            #######       //
	     0x0F, 0xE0, 0x03, 0xF8, 0x00,  //       #######           #######        //
	     0x0F, 0xE0, 0x03, 0xF8, 0x00,  //       #######           #######        //
	     0x0F, 0xE0, 0x03, 0xF8, 0x00,  //       #######           #######        //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x07, 0xF0, 0x07, 0xF0, 0x00,  //        #######         #######         //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xE0, 0x00,  //         #######       #######          //
	     0x03, 0xF8, 0x0F, 0xC0, 0x00,  //         #######       ######           //
	     0x01, 0xFC, 0x1F, 0xC0, 0x00,  //          #######     #######           //
	     0x01, 0xFC, 0x1F, 0xC0, 0x00,  //          #######     #######           //
	     0x01, 0xFC, 0x1F, 0xC0, 0x00,  //          #######     #######           //
	     0x00, 0xFE, 0x3F, 0x80, 0x00,  //           #######   #######            //
	     0x00, 0xFE, 0x3F, 0x80, 0x00,  //           #######   #######            //
	     0x00, 0xFE, 0x3F, 0x80, 0x00,  //           #######   #######            //
	     0x00, 0x7E, 0x3F, 0x00, 0x00,  //            ######   ######             //
	     0x00, 0x7F, 0x7F, 0x00, 0x00,  //            ####### #######             //
	     0x00, 0x7F, 0x7F, 0x00, 0x00,  //            ####### #######             //
	     0x00, 0x3F, 0x7E, 0x00, 0x00,  //             ###### ######              //
	     0x00, 0x3F, 0xFE, 0x00, 0x00,  //             #############              //
	     0x00, 0x3F, 0xFE, 0x00, 0x00,  //             #############              //
	     0x00, 0x1F, 0xFC, 0x00, 0x00,  //              ###########               //
	     0x00, 0x1F, 0xFC, 0x00, 0x00,  //              ###########               //
	     0x00, 0x1F, 0xFC, 0x00, 0x00,  //              ###########               //
	     0x00, 0x1F, 0xF8, 0x00, 0x00,  //              ##########                //
	     0x00, 0x0F, 0xF8, 0x00, 0x00,  //               #########                //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
	     0x00, 0x00, 0x00, 0x00, 0x00,  //                                        //
};
const uint16_t font5desc[]=
{
		    0 ,		// ,  (44)
		    0 ,		// -
		   0 ,		// .
		   0 ,		// /
		   215 ,		// 0  (48)
		   430 ,		// 1  (49)
		   645 ,		// 2  (50)
		   860 ,		// 3  (51)
		   1075 ,		// 4  (52)
		   1290 ,		// 5  (53)
		   1505 ,		// 6  (54)
		   1720 ,		// 7  (55)
		   1935 ,		// 8  (56)
		   2150 ,		// 9  (57)
		   0 ,		// :
		   0 ,		// ;
		   0 ,		// <
		   0 ,		// =
		   0 ,		// >
		   0 ,		// ?
		   0 ,		// @
		   2365 ,		// A  (65)
		   0 ,		// B
		   0 ,		// C
		   0 ,		// D
		   0 ,		// E
		   0 ,		// F
		   0 ,		// G
		   0 ,		// H
		   0 ,		// I
		   0 ,		// J
		   0 ,		// K
		   0 ,		// L
		   0 ,		// M
		   0 ,		// N
		   0 ,		// O
		   0 ,		// P
		   0 ,		// Q
		   0 ,		// R
		   0 ,		// S
		   0 ,		// T
		   0 ,		// U
		   2580 ,		// V  (86)
};
const uint8_t fontinfo5[]=
{
		 43,  // Character height
		    ',',  //  Start character
		    0,  //  number of pixels of interspace between characters
		    33,  // number of pixels of space character

};
